SystemOrganization addCategory: #'Glamour-Morphic'!

MorphTreeColumn subclass: #GLMMorphTreeColumn
	instanceVariableNames: 'glamourColumn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphTreeColumn methodsFor: 'as yet unclassified' stamp: 'tg 11/16/2009 05:01'!
glamourColumn: aColumn
	glamourColumn := aColumn! !

!GLMMorphTreeColumn methodsFor: 'as yet unclassified' stamp: 'tg 11/16/2009 05:49'!
rowMorphFor: aNodeMorph
	^ aNodeMorph rowMorphForColumn: glamourColumn.! !

PluggableShoutMorph subclass: #GLMPluggableShoutMorph
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMPluggableShoutMorph commentStamp: 'tg 4/15/2010 17:53' prior: 0!
We subclass the default PluggableShoutMorph just to raise the proper announcements when the text or when the selection changes.!

!GLMPluggableShoutMorph methodsFor: 'as yet unclassified' stamp: 'tg 4/15/2010 18:00'!
announcer
	^ announcer ifNil: [announcer := GLMAnnouncer new]! !

!GLMPluggableShoutMorph methodsFor: 'as yet unclassified' stamp: 'tg 4/15/2010 17:59'!
selectFrom: start to: stop
	| result |
	result := super selectFrom: start to: stop.
	self announcer announce: (GLMSelectedTextChanged new start: start; end: stop).
	^ result! !

GLMRenderer subclass: #GLMMorphicRenderer
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphicRenderer commentStamp: 'tg 4/1/2010 07:11' prior: 0!
This is the class responsible for the binding to Morphic.

| browser |
browser := GLMTabulator new.
browser column: #one; column: #two.

browser transmit to: #one; andShow: [:a | a list.].
browser transmit to: #two; from: #one; andShow: [ :a |
	a text.].
browser openOn: #(a b c d)!

!GLMMorphicRenderer methodsFor: 'opening' stamp: 'tg 8/24/2010 21:51'!
open: aRenderable
	window := GLMMorphicWindowRenderer render: aRenderable from: self.
	^ window openInWorld! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:31'!
renderAccordionCompositePresentation: aCompositePresentation
	^ GLMMorphicAccordionRenderer render: aCompositePresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'tg 8/24/2010 21:51'!
renderAccumulator: aBrowser 
	^ GLMMorphicAccumulatorRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'lr 6/4/2010 14:49'!
renderActionListPresentation: anActionListPresentation 
	| container buttonModel button |
	container := GLMMorphic emptyMorph.
	anActionListPresentation allActions withIndexDo: 
		[ :each :index | 
		buttonModel := GLMButtonModel new.
		buttonModel glamourPresentation: anActionListPresentation.
		buttonModel glamourAction: each.
		button := PluggableButtonMorph 
			on: buttonModel
			getState: nil
			action: #execute
			label: #buttonLabel.
		container 
			addMorph: button
			fullFrame: (LayoutFrame 
					fractions: (0 @ 0 corner: 1 @ 0)
					offsets: (0 @ ((index - 1) * 24) corner: 0 @ (index * 24))) ].
	^ container! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/24/2010 21:53'!
renderDiffPresentation: aPresentation
	^ GLMMorphicListingRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'VeronicaUquillas 5/26/2010 13:44'!
renderDropDownListPresentation: aDropListPresentation
	| listModel |

	listModel:= GLMDropListModel new glamourPresentation: aDropListPresentation.
	"When the morph changes, we want to update the glamour model"
	listModel announcer on: GLMDropDownListMorphSelectionChanged do: [ :ann | 	
		aDropListPresentation selection: ann selectionValue ].
	
	^(MorphDropListMorph
			on: listModel
			list: #list
			selected: #selectionIndex
			changeSelected: #selectionIndex:
			useIndex: true )
		hResizing: #spaceFill;
		vResizing: #shrinkWrap! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'tg 8/24/2010 21:51'!
renderFinder: aBrowser 
	^ GLMMorphicFinderRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 3/13/2010 15:30'!
renderInputPresentation: aPresentation 
	
	| morph |
	self flag: 'hook the cuis editor'.
	morph := GLMMorphic emptyMorph.
	^ morph! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 3/31/2010 22:31'!
renderLabelPresentation: aLabelPresentation 
	| morph | 
	morph := (LabelMorph contents: aLabelPresentation formatedDisplayValue) 
			layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			yourself.
	^morph! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:14'!
renderListPresentation: aListPresentation 
	^ GLMMorphicListRenderer render: aListPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:12'!
renderListingPresentation: aPresentation 
	^ GLMMorphicListingRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/12/2010 16:52'!
renderMagrittePresentation: aMagrittePresentation 
	| toShow description magritteMorph scrollPane |
	toShow := aMagrittePresentation displayValue.
	description := (aMagrittePresentation magritteDescription glamourValue: toShow) copy.
	description morphClass: MASilentContainerMorph.
	magritteMorph := (description asMorphOn: toShow)
		addButtons;
		morph.
	scrollPane := GLMScrollPaneForHResize new.
	scrollPane scroller
		addMorph: magritteMorph
		";
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		layoutChanged".
	scrollPane layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1) offsets: (0 @ 25 corner: 0 @ 0)).

	aMagrittePresentation when: GLMPresentationUpdated do: [:ann |
		scrollPane scroller removeMorph: scrollPane scroller submorphs first.
		toShow := aMagrittePresentation displayValue.
		description := (aMagrittePresentation magritteDescription glamourValue: toShow) copy.
		description morphClass: MASilentContainerMorph.
		magritteMorph := (description asMorphOn: toShow)
			addButtons;
			morph.
		scrollPane scroller addMorph: magritteMorph].

	^ scrollPane! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/23/2010 00:22'!
renderMondrianPresentation: aPresentation
	^ GLMMorphicMondrianRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'lr 11/7/2009 11:42'!
renderMorphPresentation: aMorphPresentation 
	^ aMorphPresentation displayValue! !

!GLMMorphicRenderer methodsFor: 'rendering' stamp: 'tg 8/24/2010 21:51'!
renderPane: aPane 
	^ GLMMorphicPaneRenderer render: aPane from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:31'!
renderStackedVerticallyCompositePresentation: aCompositePresentation
	^ GLMMorphicVerticallyStackedRenderer render: aCompositePresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'tg 8/24/2010 21:50'!
renderStacker: aBrowser 
	^ GLMMorphicStackerRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:33'!
renderTabbedCompositePresentation: aCompositePresentation
	^ GLMMorphicTabbedRenderer render: aCompositePresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:15'!
renderTablePresentation: aPresentation 
	^ GLMMorphicTableRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'tg 8/24/2010 21:50'!
renderTabulator: aBrowser 
	^ GLMMorphicTabulatorRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 20:22'!
renderTextPresentation: aTextPresentation 
	^ GLMMorphicTextRenderer render: aTextPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:16'!
renderTreePresentation: aPresentation 
	^ GLMMorphicTreeRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'accessing' stamp: 'tg 8/23/2010 00:33'!
window
	^ window! !

!GLMMorphicRenderer methodsFor: 'accessing' stamp: 'tg 8/23/2010 00:33'!
window: anObject
	window := anObject! !

StandardWindow subclass: #GLMSystemWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMSystemWindow methodsFor: 'building' stamp: ''!
buildWindowMenu
	^ self model actions isEmpty
		ifTrue: [ super buildWindowMenu ]
		ifFalse: [
			self model actions
				inject: (super buildWindowMenu
					addLine;
					yourself)
				into: [ :menu :action |
					menu
						add: action title target: action selector: #actOn: argument: self model;
						yourself ] ]! !

!GLMSystemWindow methodsFor: 'as yet unclassified' stamp: 'tg 1/31/2010 00:26'!
delete
	self model unregisterFromAllAnnouncements.
	super delete! !

!GLMSystemWindow methodsFor: 'building' stamp: 'tg 11/5/2009 15:56'!
extent: aPoint 
	super extent: aPoint.
	self fullBounds.
	self refreshHorizontalScollbars.! !

!GLMSystemWindow methodsFor: 'building' stamp: 'tg 3/4/2010 23:23'!
refreshHorizontalScollbars
	self flag: 'this was somehow needed when the magritte form was embedded in a scroll pane'
"	self allMorphsDo: 
		[ :morph | 
		(morph isKindOf: GLMScrollPaneForHResize) ifTrue: [ 
			morph scroller submorphs anyOne width: morph scroller width - 20 ] ]"! !

TabGroupMorph subclass: #LazyTabGroupMorph
	instanceVariableNames: 'lazyPages onPageIndexChange'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'jre 7/24/2009 15:12'!
addLazyPage: aBlock label: aStringOrMorph
	self lazyPages add: aBlock.
	self tabSelectorMorph addTab: aStringOrMorph! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'jre 7/24/2009 15:44'!
addPage: aMorph 
	aMorph
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	^self pages add: aMorph.! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'jre 8/7/2009 10:16'!
addPage: aMorph at: anIndex
	aMorph
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	^self pages at: anIndex put: aMorph! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'tg 8/12/2010 17:49'!
clear
	self flag: 'todo'.
"	tabSelectorMorph submorphs do: [:each |
		tabSelectorMorph removeMorph: each ].
	lazyPages := OrderedCollection new.
	pageMorphs := Dictionary new."! !

!LazyTabGroupMorph methodsFor: 'initialization' stamp: 'tg 8/12/2010 17:28'!
initialize
	super initialize.
	lazyPages := OrderedCollection new.
	pageMorphs := Dictionary new.! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'jre 7/24/2009 15:12'!
lazyPages

	^lazyPages! !

!LazyTabGroupMorph methodsFor: 'accessing' stamp: 'tg 6/12/2010 15:19'!
onPageIndexChange
	^ onPageIndexChange ifNil: [[:x | ]]! !

!LazyTabGroupMorph methodsFor: 'accessing' stamp: 'tg 10/18/2009 19:36'!
onPageIndexChange: anObject
	onPageIndexChange := anObject! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'jre 8/7/2009 10:16'!
pageAt: index
	^self pages at: index ifAbsent: [ self addPage: (self lazyPages at: index) value at: index]! !

!LazyTabGroupMorph methodsFor: 'as yet unclassified' stamp: 'tg 10/18/2009 19:38'!
updatePageIndex: index
	"Change to the given page index."

	|p|
	p := self pageMorph.
	p isNil
		ifTrue: [self contentMorph addMorph: (self pageAt: index)]
		ifFalse: [self contentMorph
				replaceSubmorph: p
				by: (self pageAt: index)].
	self pageMorph layoutChanged.
	self adoptPaneColor: (self owner ifNil: [self]) paneColor.
	self onPageIndexChange value: index! !

Announcement subclass: #GLMActionAnnouncement
	instanceVariableNames: 'action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMActionAnnouncement classSide methodsFor: 'instance creation' stamp: 'david_roethlisberger 3/3/2009 16:28'!
action: anAction
	^self new action: anAction; yourself! !

!GLMActionAnnouncement methodsFor: 'accessing' stamp: 'david_roethlisberger 3/3/2009 16:28'!
action
	^action! !

!GLMActionAnnouncement methodsFor: 'accessing' stamp: 'david_roethlisberger 3/3/2009 16:28'!
action: anAction
	action := anAction! !

GLMActionAnnouncement subclass: #GLMKeyStroke
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

GLMActionAnnouncement subclass: #GLMMenuInvoked
	instanceVariableNames: 'menuMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMenuInvoked classSide methodsFor: 'as yet unclassified' stamp: 'jre 7/31/2009 15:24'!
action: anAction on: aMenuMorph 
	^self new initializeAction: anAction on: aMenuMorph! !

!GLMMenuInvoked methodsFor: 'initialization' stamp: 'jre 7/31/2009 15:43'!
initializeAction: anAction on: aMenuMorph 
	self action: anAction.
	menuMorph := aMenuMorph! !

!GLMMenuInvoked methodsFor: 'accessing' stamp: 'jre 7/31/2009 15:43'!
menuMorph
	^menuMorph! !

GLMActionAnnouncement subclass: #GLMMenuItemSelected
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

Announcement subclass: #GLMDropDownListMorphSelectionChanged
	instanceVariableNames: 'selectionValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMDropDownListMorphSelectionChanged methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/18/2010 20:15'!
selectionValue
	^ selectionValue! !

!GLMDropDownListMorphSelectionChanged methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/18/2010 20:15'!
selectionValue: anObject
	selectionValue := anObject! !

Announcement subclass: #GLMSelectedTextChanged
	instanceVariableNames: 'start end selectedText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMSelectedTextChanged methodsFor: 'accessing' stamp: 'tg 4/15/2010 17:55'!
end
	^ end! !

!GLMSelectedTextChanged methodsFor: 'accessing' stamp: 'tg 4/15/2010 17:55'!
end: anObject
	end := anObject! !

!GLMSelectedTextChanged methodsFor: 'accessing' stamp: 'tg 4/15/2010 17:55'!
selectedText
	^ selectedText! !

!GLMSelectedTextChanged methodsFor: 'accessing' stamp: 'tg 4/15/2010 17:55'!
selectedText: anObject
	selectedText := anObject! !

!GLMSelectedTextChanged methodsFor: 'accessing' stamp: 'tg 4/15/2010 17:55'!
start
	^ start! !

!GLMSelectedTextChanged methodsFor: 'accessing' stamp: 'tg 4/15/2010 17:55'!
start: anObject
	start := anObject! !

Announcement subclass: #GLMTreeMorphSelectionChanged
	instanceVariableNames: 'selectionValue selectionPathValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMTreeMorphSelectionChanged methodsFor: 'accessing' stamp: 'tg 12/29/2009 01:56'!
selectionPathValue
	^ selectionPathValue! !

!GLMTreeMorphSelectionChanged methodsFor: 'accessing' stamp: 'tg 12/29/2009 01:56'!
selectionPathValue: anObject
	selectionPathValue := anObject! !

!GLMTreeMorphSelectionChanged methodsFor: 'accessing' stamp: 'tg 12/29/2009 01:54'!
selectionValue
	^ selectionValue! !

!GLMTreeMorphSelectionChanged methodsFor: 'accessing' stamp: 'tg 12/29/2009 01:54'!
selectionValue: anObject
	selectionValue := anObject! !

Announcement subclass: #GLMTreeMorphStrongSelectionChanged
	instanceVariableNames: 'strongSelectionValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMTreeMorphStrongSelectionChanged methodsFor: 'accessing' stamp: 'tg 12/29/2009 01:58'!
strongSelectionValue
	^ strongSelectionValue! !

!GLMTreeMorphStrongSelectionChanged methodsFor: 'accessing' stamp: 'tg 12/29/2009 01:58'!
strongSelectionValue: anObject
	strongSelectionValue := anObject! !

UIThemeWatery2 subclass: #GLMUITheme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMUITheme classSide methodsFor: 'accessing' stamp: 'tg 9/1/2010 08:54'!
baseColor
	^ Color r: 180 g: 180 b: 180 range: 255! !

!GLMUITheme classSide methodsFor: 'accessing' stamp: 'tg 8/31/2010 22:51'!
baseSelectionColor
	^ self glamorousBlue! !

!GLMUITheme classSide methodsFor: 'settings' stamp: 'tg 9/2/2010 13:22'!
beCurrent
	"self beCurrent"
	super beCurrent.
	World color: (
		(GradientFillStyle 
			ramp: { 0.0 -> Color white.  1.0 -> Color lightGray})
			origin: 50 @ 50;
			direction: 800@0;
			normal: 0@800;
		radial: true)! !

!GLMUITheme classSide methodsFor: 'private' stamp: 'tg 8/31/2010 23:38'!
glamorousBlue
	^ Color 
		r: 0.38
		g: 0.64
		b: 0.88
	"Color r: 0
		g: 0.4
		b: 0.808"! !

!GLMUITheme classSide methodsFor: 'settings' stamp: 'tg 9/1/2010 09:02'!
newDefaultSettings
	^super newDefaultSettings
		menuColor: self baseColor;
		menuTitleColor: self baseColor;
		windowColor: self baseColor;
		selectionColor: self baseSelectionColor muchLighter;
		menuSelectionColor: self baseSelectionColor twiceLighter;
		progressBarColor: self baseColor
		
	"Answer a new original default settings."
	"self defaultSettings: nil"
"	^super newDefaultSettings
		standardColorsOnly: true;
		autoSelectionColor: false;
		buttonColor: (Color r: 232 g: 232 b: 232 range: 255);
		windowColor: (Color r: 232 g: 232 b: 232 range: 255);
		scrollbarColor: (Color r: 62 g: 142 b: 220 range: 255) ;
		selectionColor: (TranslucentColor r: 0.0 g: 0.0 b: 0.8 alpha: 0.2) ;
		menuSelectionColor: (Color r: 51 g: 76 b: 230 range: 255) ;
		progressBarColor: (Color r: 232 g: 232 b: 232 range: 255);
		progressBarProgressColor: (Color r: 62 g: 142 b: 220 range: 255)"! !

!GLMUITheme classSide methodsFor: 'accessing' stamp: 'tg 1/14/2010 03:12'!
themeName
	^ 'Glamorous'! !

!GLMUITheme methodsFor: 'private' stamp: 'tg 8/31/2010 22:02'!
buttonBaseColorFor: aButton
	^ self class baseColor
	
	"unfortunately, it looks like paneColor does not always return the wanted color"
	"aButton paneColorOrNil ifNil: [Color r: 200 g: 200 b: 200 range: 255]"! !

!GLMUITheme methodsFor: 'private' stamp: 'tg 9/1/2010 08:57'!
buttonBaseSelectionColorFor: aButton
	^ self class baseSelectionColor
	
	"unfortunately, it looks like paneColor does not always return the wanted color"
	"aButton paneColorOrNil ifNil: [Color r: 200 g: 200 b: 200 range: 255]"! !

!GLMUITheme methodsFor: 'border-styles-buttons' stamp: 'tg 8/31/2010 13:10'!
buttonCornerStyleIn: aThemedMorph
	"Allow for themes to override default behaviour."
	
	^ #square
	"^aThemedMorph
		ifNil: [#rounded]
		ifNotNil: [:tm | 
			tm preferredButtonCornerStyle
				ifNil: [#rounded]
				ifNotNil: [:bcs | bcs]]"! !

!GLMUITheme methodsFor: 'label-styles' stamp: 'tg 8/31/2010 08:32'!
buttonLabelForText: aTextOrString
	"Answer the label to use for the given text."
	^aTextOrString isString
		ifTrue: [(LabelMorph contents: aTextOrString) color: Color black]
		ifFalse: [super buttonLabelForText: aTextOrString]! !

!GLMUITheme methodsFor: 'defaults' stamp: 'tg 8/31/2010 00:32'!
buttonMinHeight
	"Answer the minumum height of a button for this theme."
	
	^20! !

!GLMUITheme methodsFor: 'defaults' stamp: 'tg 8/31/2010 14:33'!
buttonMinWidth
	"Answer the minumum width of a button for this theme."
	
	^20! !

!GLMUITheme methodsFor: 'border-styles-buttons' stamp: 'tg 8/31/2010 23:12'!
buttonNormalBorderStyleFor: aButton
	"Return the normal button borderStyle for the given button."

	| outerColor innerColor |
	(aButton valueOfProperty: #noBorder ifAbsent: [false]) ifTrue: [
		^ SimpleBorder new width: 0; baseColor: Color transparent ].
	outerColor := (self buttonBaseColorFor: aButton) darker.
	^SimpleBorder new
					width: 1;
					baseColor: outerColor! !

!GLMUITheme methodsFor: 'fill-styles-buttons' stamp: 'tg 8/31/2010 23:08'!
buttonNormalFillStyleFor: aButton
	"Return the normal button fillStyle for the given button."
	
	| toptop top bottom base |
	(aButton valueOfProperty: #noFill ifAbsent: [false]) ifTrue: [^ SolidFillStyle color: Color transparent ].
	base := self buttonBaseColorFor: aButton.
	toptop := base muchLighter.
	top := base twiceLighter.
	bottom := base.
	^(GradientFillStyle ramp: {
			0.0->toptop.
			0.05->top.
			0.8->bottom.})
		origin: aButton bounds origin;
		direction: 0 @ aButton height;
		radial: false! !

!GLMUITheme methodsFor: 'border-styles-buttons' stamp: 'tg 8/31/2010 11:09'!
buttonSelectedBorderStyleFor: aButton
	^ self buttonNormalBorderStyleFor: aButton! !

!GLMUITheme methodsFor: 'fill-styles-buttons' stamp: 'tg 9/1/2010 08:58'!
buttonSelectedFillStyleFor: aButton
	"Return the normal button fillStyle for the given button."
	
	| toptop top bottom base |
	base := self buttonBaseColorFor: aButton.
	toptop := base muchLighter.
	top := (self buttonBaseSelectionColorFor: aButton) muchLighter.
	bottom := base.

	^(GradientFillStyle ramp: {
			0.0->toptop.
			0.05->top.
			0.8->bottom.})
		origin: aButton bounds origin;
		direction: 0 @ aButton height;
		radial: false! !

!GLMUITheme methodsFor: 'border-styles' stamp: 'tg 8/31/2010 13:08'!
configureWindowBorderFor: aWindow
	super configureWindowBorderFor: aWindow.
	aWindow roundedCorners: #() "not even top"! !

!GLMUITheme methodsFor: 'fill-styles' stamp: 'tg 9/2/2010 13:52'!
dockingBarNormalFillStyleFor: aToolDockingBar
	^ SolidFillStyle color: (self buttonBaseColorFor: aToolDockingBar)! !

!GLMUITheme methodsFor: 'initialize-release' stamp: 'tg 8/31/2010 13:51'!
initialize
	"self beCurrent"

	super initialize.
	self windowActiveDropShadowStyle: #nodiffuse! !

!GLMUITheme methodsFor: 'fill-styles-buttons' stamp: 'tg 8/31/2010 16:31'!
menuItemInDockingBarSelectedFillStyleFor: aMenuItem
	"Answer the selected fill style to use for the given menu item that is in a docking bar."
	
	| fill baseColor |
	Display depth <= 2
		ifTrue: [^ Color gray].
	baseColor := self settings derivedMenuColor.
	self preferGradientFill ifFalse: [^baseColor].
	fill := GradientFillStyle ramp: {0.0 -> baseColor twiceDarker . 1 -> baseColor twiceLighter}.
	fill
		origin: aMenuItem topLeft;
		direction: 0@aMenuItem height.
	^ fill! !

!GLMUITheme methodsFor: 'morph creation' stamp: 'tg 9/1/2010 08:58'!
newFocusIndicatorMorphFor: aMorph
	"Answer a new focus indicator for the given morph."

	|radius|
	radius := aMorph focusIndicatorCornerRadius.
	^ BorderedMorph new
		fillStyle: Color transparent;
		borderStyle: (SimpleBorder new
			 width: 1;
			baseColor: (self buttonBaseSelectionColorFor: aMorph) lighter);
		bounds: aMorph focusBounds! !

!GLMUITheme methodsFor: 'initialize-release' stamp: 'tg 9/2/2010 23:25'!
newWindowCloseForm
	"Answer a new form for a window close box."

	^(Form
	extent: 16@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290361785 4285822068 4282071867 4279440147 4279440147 4282071867 4285822068 4290361785 0 0 0 0 0 0 0 4287335307 4281808438 4283254086 4286543478 4288254096 4288188560 4286543478 4283254086 4281808438 4287335307 0 0 0 0 0 4287138185 4280425243 4285027670 4289633180 4292135884 4293254878 4293320928 4292267469 4289567644 4285093206 4280490779 4287203978 0 0 0 4290164406 4282134834 4284233271 4288637549 4291401881 4292653234 4292850869 4292785333 4292653234 4291467161 4288637549 4284364600 4282266163 4290230199 0 0 4286545534 4283178015 4287182138 4289281086 4290597711 4290995037 4291126110 4291126109 4290929244 4290662991 4289281086 4287182394 4283309344 4286611327 0 0 4283383359 4285867306 4288685092 4289799715 4290590512 4290856252 4290988611 4291054147 4290922044 4290590256 4289930531 4288619300 4285867562 4283711040 0 0 4282782229 4287833644 4289996837 4290787376 4291381825 4291909968 4292173910 4292239446 4292106833 4291578692 4290984239 4290193702 4287833644 4283044630 0 0 4284026900 4289014315 4291051835 4291973448 4292633434 4293226345 4293556336 4293622129 4293358699 4292896092 4292236105 4291445307 4289014058 4284092436 0 0 4285414719 4289343786 4291712331 4293027933 4293949038 4294280317 4294479236 4294479236 4294346110 4294015086 4293224799 4291974475 4289343785 4285545791 0 0 4287264888 4288555300 4292239449 4293818479 4294542716 4294546314 4294614419 4294614676 4294546828 4294543230 4293884271 4292501850 4288751652 4287330424 0 0 4290558650 4286658615 4291253841 4293951868 4294481292 4294615447 4294617247 4294618017 4294616217 4294481550 4294214781 4291779154 4286789430 4290493114 0 0 4292664540 4288385426 4287573545 4292374633 4293892240 4294289824 4294555050 4294555308 4294356387 4293958547 4292835183 4287836460 4288385426 4292664540 0 0 0 4292993505 4288320403 4286993487 4289421400 4291463295 4292845463 4293043354 4291660419 4289684573 4287256400 4288254867 4292993505 0 0 0 0 0 4292927712 4291282630 4287858566 4286996058 4286533190 4286598726 4287324509 4287858309 4291348680 4292927712 0 0 0 0 0 0 0 4292401368 4293125091 4293454056 4293190884 4293190884 4293190884 4293125091 4292401368 0 0 0 0)
	offset: 0@0)! !

!GLMUITheme methodsFor: 'initialize-release' stamp: 'tg 9/2/2010 23:24'!
newWindowMaximizeForm
	"Answer a new form for a window maximize box."

	^(Form
	extent: 16@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290295992 4285822068 4282071867 4279440147 4279440147 4282071867 4285822068 4290295992 0 0 0 0 0 0 0 4287269514 4281611316 4282795590 4285953654 4287664528 4287730320 4285953654 4282861383 4281611316 4287269514 0 0 0 0 0 4287137928 4280360481 4283914839 4288455580 4291547084 4292731360 4292796894 4291547341 4288390044 4283980376 4280294689 4287203721 0 0 0 4290164406 4281348144 4282010170 4285369453 4288527772 4290565299 4291025080 4291025080 4290630835 4288593820 4285303917 4282009913 4281348144 4290164406 0 0 4286479998 4280431648 4282282296 4283995198 4286033222 4286821198 4286952786 4287018578 4286755662 4285967429 4284060735 4282216504 4280497696 4286545791 0 0 4282402111 4281097769 4282549797 4283800345 4284982554 4285771048 4285903149 4285837356 4285771304 4285114397 4283866393 4282484773 4281097769 4282402111 0 0 4279972116 4282219307 4283997212 4285114906 4285969451 4286824254 4287152961 4287218498 4286890301 4286167084 4285246490 4284260124 4282219308 4280037908 0 0 4279975186 4283600171 4285640744 4286561842 4287547718 4288336981 4288731227 4288731228 4288402775 4287614279 4286627889 4285772072 4283600683 4280172817 0 0 4282736189 4284126245 4286692666 4287877449 4288797275 4289586536 4290112367 4290112368 4289718377 4288863579 4287877448 4286758970 4284126756 4282803005 0 0 4286284920 4283533850 4287283524 4288731993 4289718632 4290507893 4291099774 4291165055 4290705785 4289850729 4288797788 4287415878 4283599642 4286350968 0 0 4290362041 4283331374 4286560575 4289322854 4290770809 4291559299 4291952522 4292083595 4291690372 4290903163 4289455464 4286889281 4283462959 4290362040 0 0 4292664540 4287928465 4283793702 4288007509 4290572412 4291689100 4292607381 4292607382 4291885710 4290900861 4288666201 4284122406 4287928465 4292664540 0 0 0 4292993505 4288059538 4284842051 4286688328 4289384043 4290962050 4291224710 4289646450 4287083084 4285171781 4287928466 4292993505 0 0 0 0 0 4292927712 4291217093 4287402885 4285630033 4284907832 4284973881 4285893715 4287468677 4291348680 4292927712 0 0 0 0 0 0 0 4292401368 4293125091 4293454056 4293190884 4293190884 4293190884 4293125091 4292401368 0 0 0 0)
	offset: 0@0)! !

!GLMUITheme methodsFor: 'initialize-release' stamp: 'tg 9/2/2010 23:24'!
newWindowMenuForm
	"Answer a new form for a window menu box."

	^(Form
	extent: 24@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4293125091 4287335307 4283453520 4281150765 4280690214 4280821800 4280821800 4280821800 4280821800 4280821800 4280821800 4280821800 4280821800 4280690214 4281150765 4283453520 4287335307 4293125091 0 0 0 0 0 4293059298 4285493103 4282795590 4287072135 4289638062 4290493371 4290822336 4290756543 4290756543 4290822336 4290822336 4290756543 4290756543 4290822336 4290493371 4289638062 4287072135 4282795590 4285493103 4293059298 0 0 0 0 4287335307 4282598211 4288322202 4291875024 4292927712 4293322470 4293519849 4293519849 4293519849 4293519849 4293519849 4293519849 4293519849 4293519849 4293322470 4292927712 4291875024 4288322202 4282598211 4287401100 0 0 0 0 4283585106 4285953654 4289967027 4291677645 4292269782 4292401368 4292401368 4292401368 4292335575 4292335575 4292335575 4292335575 4292401368 4292401368 4292401368 4292269782 4291677645 4289967027 4285953654 4283585106 0 0 0 0 4281742902 4287861651 4290493371 4291085508 4291480266 4291546059 4291611852 4291611852 4291546059 4291480266 4291480266 4291546059 4291611852 4291611852 4291546059 4291480266 4291085508 4290493371 4287861651 4281742902 0 0 0 0 4281940281 4288782753 4291414473 4292203989 4292664540 4292796126 4292927712 4292796126 4292861919 4292927712 4292927712 4292861919 4292796126 4292927712 4292796126 4292664540 4292203989 4291414473 4288782753 4281874488 0 0 0 0 4284045657 4288256409 4291546059 4293190884 4294177779 4294572537 4294440951 4294572537 4294506744 4294572537 4294572537 4294506744 4294572537 4294440951 4294572537 4294177779 4293190884 4291546059 4288256409 4284045657 0 0 0 0 4287269514 4283914071 4290624957 4293190884 4294638330 4294769916 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294835709 4294769916 4294638330 4293190884 4290624957 4283914071 4287269514 0 0 0 0 4292467161 4286414205 4283387727 4287993237 4291019715 4292269782 4292467161 4292467161 4292467161 4292467161 4292467161 4292467161 4292467161 4292467161 4292598747 4291611852 4287993237 4283387727 4286414205 4292467161 0 0 0 0 4292401368 4292467161 4288124823 4284177243 4281150765 4280229663 4280361249 4280361249 4280361249 4280361249 4280361249 4280361249 4280361249 4280361249 4280229663 4281282351 4284177243 4288124823 4292467161 4292401368 0 0 0 0 0 4292203989 4292203989 4292335575 4292401368 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292927712 4292664540 4292401368 4292335575 4292269782 4292203989 0 0 0 0 0 0 0 4292006610 4292401368 4292467161 4292730333 4292730333 4292730333 4292730333 4292730333 4292730333 4292730333 4292730333 4292730333 4292796126 4292467161 4292401368 4292006610 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!GLMUITheme methodsFor: 'initialize-release' stamp: 'tg 9/2/2010 23:24'!
newWindowMinimizeForm
	"Answer a new form for a window minimize box."

	^(Form
	extent: 16@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4290295992 4285953140 4282726971 4280619283 4280619283 4282661434 4285953140 4290295992 0 0 0 0 0 0 0 4287400586 4282921779 4284629572 4287526262 4288909456 4288974992 4287591798 4284761414 4282856243 4287400586 0 0 0 0 0 4287334536 4282588703 4286796631 4290682268 4292529868 4293385950 4293385950 4292529612 4290682268 4286731095 4282654242 4287400329 0 0 0 4290164406 4283247407 4286332215 4290281068 4292457116 4293447349 4293579448 4293579447 4293447349 4292457116 4290346605 4286660409 4283771952 4290164406 0 0 4287004286 4284555291 4289551160 4291461439 4292647750 4292978252 4292978510 4292978510 4292912459 4292516422 4291461695 4289485625 4285736224 4287004543 0 0 4284694079 4287316261 4291129383 4292379927 4292907543 4293237538 4293434920 4293369896 4293303330 4293104407 4292380439 4291130151 4288301098 4284694078 0 0 4285013269 4289947179 4292577049 4293498387 4293959974 4294159159 4294291774 4294357567 4294291256 4294091813 4293695508 4292774682 4290144044 4285013782 0 0 4286197779 4291263275 4293565218 4294486826 4294752322 4294754384 4294624599 4294756183 4294755663 4294753345 4294618155 4293828129 4291395115 4286263315 0 0 4286797373 4291592487 4294093364 4294753602 4294822482 4294825059 4294826346 4294826603 4294825828 4294822740 4294753602 4294225462 4291855399 4286928446 0 0 4287791736 4290870043 4294029633 4294691156 4294826081 4294894447 4294962297 4294963066 4294895474 4294892130 4294691669 4294096449 4291001115 4287857272 0 0 4290558649 4287916079 4292847677 4294431071 4294829938 4294964349 4294965892 4294966661 4294964606 4294896499 4294563169 4292980029 4287981872 4290558648 0 0 4292664540 4288452497 4288312611 4292590416 4294239351 4294636933 4294835601 4294835346 4294637704 4294306681 4293052245 4288576291 4288452497 4292664540 0 0 0 4292993505 4288321426 4287199810 4289700930 4291873639 4293321856 4293387137 4292005738 4290096709 4287463236 4288321426 4292993505 0 0 0 0 0 4292927712 4291282629 4287861124 4287137103 4286939445 4286939701 4287532112 4287926916 4291348680 4292927712 0 0 0 0 0 0 0 4292401368 4293125091 4293454056 4293190884 4293190884 4293190884 4293125091 4292401368 0 0 0 0)
	offset: 0@0)! !

!GLMUITheme methodsFor: 'border-styles' stamp: 'tg 9/1/2010 09:09'!
plainGroupPanelBorderStyleFor: aGroupPanel
	"Answer the normal border style for a plain group panel."

	^SimpleBorder new
		width: 1;
		baseColor: (self buttonBaseColorFor: aGroupPanel) lighter! !

!GLMUITheme methodsFor: 'fill-styles' stamp: 'tg 8/31/2010 22:49'!
progressBarFillStyleFor: aProgressBar
	^ (self buttonBaseColorFor: aProgressBar) muchLighter! !

!GLMUITheme methodsFor: 'fill-styles' stamp: 'tg 8/31/2010 22:51'!
progressBarProgressFillStyleFor: aProgressBar
	^ self class baseSelectionColor muchLighter! !

!GLMUITheme methodsFor: 'fill-styles' stamp: 'tg 1/14/2010 03:10'!
resizerGripNormalFillStyleFor: aResizer
	"Return the normal fillStyle for the given resizer.
	For the moment, answer a transparent colour for no drawing,
	non transparent to draw as normal."
	
	^Color transparent! !

!GLMUITheme methodsFor: 'fill-styles-scrollbars' stamp: 'tg 8/31/2010 15:31'!
scrollbarNormalButtonFillStyleFor: aScrollbar
	"Return the normal scrollbar button fillStyle for the given scrollbar."
	
	^ (self buttonNormalFillStyleFor: aScrollbar) 
		direction: (aScrollbar bounds isWide
			ifTrue: [0 @ aScrollbar height]
			ifFalse: [aScrollbar width @ 0])! !

!GLMUITheme methodsFor: 'fill-styles-scrollbars' stamp: 'tg 9/1/2010 09:25'!
scrollbarNormalFillStyleFor: aScrollbar
	"Return the normal scrollbar fillStyle for the given scrollbar."
	
	^ (self buttonBaseColorFor: aScrollbar) muchLighter! !

!GLMUITheme methodsFor: 'fill-styles-scrollbars' stamp: 'tg 8/31/2010 13:23'!
scrollbarNormalThumbFillStyleFor: aScrollbar
	"Return the normal scrollbar fillStyle for the given scrollbar."
	
	^ (self buttonNormalFillStyleFor: aScrollbar) 
		direction: (aScrollbar bounds isWide
			ifTrue: [0 @ aScrollbar height]
			ifFalse: [aScrollbar width @ 0])! !

!GLMUITheme methodsFor: 'border-styles-scrollbars' stamp: 'tg 8/31/2010 13:27'!
scrollbarPagingAreaCornerStyleIn: aThemedMorph	
	^#square! !

!GLMUITheme methodsFor: 'border-styles-scrollbars' stamp: 'tg 8/31/2010 13:27'!
scrollbarThumbCornerStyleIn: aThemedMorph	
	^#square! !

!GLMUITheme methodsFor: 'fill-styles' stamp: 'tg 1/14/2010 03:11'!
splitterNormalFillStyleFor: aSplitter
	"Return the normal splitter fillStyle for the given splitter."
	
	^SolidFillStyle color: Color transparent! !

!GLMUITheme methodsFor: 'fill-styles' stamp: 'tg 8/31/2010 16:58'!
splitterPressedFillStyleFor: aSplitter
	"Return the pressed splitter fillStyle for the given splitter."
	
	|aColor|
	aColor := self buttonBaseColorFor: aSplitter.
	^(GradientFillStyle ramp: {
			0.0->Color white. 0.6-> aColor.
			1.0->aColor darker})
		origin: aSplitter topLeft;
		direction: (aSplitter splitsTopAndBottom
			ifTrue: [0 @ aSplitter height]
			ifFalse: [aSplitter width @ 0]);
		radial: false! !

!GLMUITheme methodsFor: 'basic-colors' stamp: 'tg 9/1/2010 09:23'!
subgroupColorFrom: paneColor
	"Answer the colour for a subgroup given the pane colour."

	^ self class baseColor" paneColor"! !

!GLMUITheme methodsFor: 'border-styles' stamp: 'tg 8/31/2010 15:28'!
tabLabelNormalBorderStyleFor: aTabLabel
"	^SimpleBorder new
		width: 0;
		baseColor: (self buttonBaseColorFor: aTabLabel) darker
"	^ self buttonNormalBorderStyleFor: aTabLabel! !

!GLMUITheme methodsFor: 'fill-styles-buttons' stamp: 'tg 8/31/2010 11:13'!
tabLabelNormalFillStyleFor: aTabLabel
	^ self buttonNormalFillStyleFor: aTabLabel ! !

!GLMUITheme methodsFor: 'fill-styles-buttons' stamp: 'tg 8/31/2010 11:13'!
tabLabelSelectedFillStyleFor: aTabLabel
	^ self buttonSelectedFillStyleFor: aTabLabel ! !

!GLMUITheme methodsFor: 'border-styles' stamp: 'tg 9/1/2010 09:09'!
tabPanelBorderStyleFor: aTabGroup
	"Answer the normal border style for a tab panel."

	^ TabPanelBorder new
		width: 1;
		baseColor: ((self buttonBaseColorFor: aTabGroup));
		tabSelector: aTabGroup tabSelectorMorph! !

!GLMUITheme methodsFor: 'basic-colors' stamp: 'tg 9/2/2010 14:22'!
taskbarButtonLabelColorFor: aButton
	"Answer the colour for the label of the given taskbar button."

	^aButton model
		ifNil: [super taskbarButtonLabelColorFor: aButton]
		ifNotNil: [:win |
			win isActive
				ifTrue: [self class baseSelectionColor muchDarker]
				ifFalse: [Color black]]! !

!GLMUITheme methodsFor: 'fill-styles' stamp: 'tg 8/31/2010 12:51'!
taskbarFillStyleFor: aTaskbar
	^ self buttonNormalFillStyleFor: aTaskbar! !

!GLMUITheme methodsFor: 'fill-styles' stamp: 'tg 9/2/2010 13:52'!
windowInactiveFillStyleFor: aWindow
	"We do not want the lighting effect when the window goes inactive"
	^self windowActiveFillStyleFor: aWindow! !

!GLMUITheme methodsFor: 'fill-styles' stamp: 'tg 9/2/2010 13:51'!
windowInactiveTitleFillStyleFor: aWindow
	"We do not want the lighting effect when the window goes inactive"
	^self windowActiveTitleFillStyleFor: aWindow! !

MorphTreeNodeModel subclass: #GLMTreeMorphNodeModel
	instanceVariableNames: 'contents containerTree onSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMTreeMorphNodeModel methodsFor: 'callbacks' stamp: 'VeronicaUquillas 6/15/2010 11:13'!
buttonForTag: each filter: filter
	| button |

	button := GLMMorphic 
		togglingButtonLabelled: each
		pressed: (self containerTree shouldFilterByTag: filter)
		style: self containerTree glamourPresentation tagsStyle.
	button
		target: self;
		actionSelector: #toggleFilteringByTag:;
		arguments: (Array with: filter).
	^ button! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 4/18/2010 23:19'!
childrenItems
	^ (self containerTree glamourPresentation childrenValueOf: self item atLevel: self path size) ifNil: [OrderedCollection new]! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 21:08'!
containerTree
	^ containerTree! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 21:08'!
containerTree: anObject
	containerTree := anObject! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 11/30/2009 02:10'!
contents
	| allContents |
	^ contents ifNil: 
		[ allContents := self childrenItems collect: [ :d | 
			(self class with: d)
				parentNode: self;
				containerTree: self containerTree;
				yourself ].
		contents := allContents select: [ :each | each shouldBeDisplayed ] ]! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/9/2009 00:59'!
displayText
	^ UITheme current 
		newTextIn: World
		text: (self containerTree glamourPresentation formatedDisplayValueOf: self item) ! !

!GLMTreeMorphNodeModel methodsFor: 'callbacks' stamp: 'VeronicaUquillas 11/19/2009 22:44'!
elementColumn
	| row tags tagsFilter |
	row := OrderedCollection with: self displayText.
	tags:= self containerTree glamourPresentation tagsFor: self item to: #show.
	tagsFilter := self containerTree glamourPresentation tagsFor: self item to: #filter.
	tags withIndexDo:[ :each :index | 
			row addLast: (self buttonForTag: each 
									  filter: (tagsFilter at: index ifAbsentPut:[ each ])) ].
	^ UITheme current newRowIn: World for: row! !

!GLMTreeMorphNodeModel methodsFor: 'testing' stamp: 'alain.plantec 9/8/2009 14:37'!
enabled
	^ true! !

!GLMTreeMorphNodeModel methodsFor: 'menu' stamp: 'tg 9/16/2009 23:39'!
executeMenuAction: anAction
	self containerTree announce: (GLMMenuItemSelected action: anAction)! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 11/2/2009 01:19'!
expandParentPath
"	self openItemPath: anArray"
	self containerTree changed: {#roots. #openItemPath}, (self path collect: [:each | each item]).! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/11/2009 19:54'!
icon
	^ self containerTree glamourPresentation iconFor: self item! !

!GLMTreeMorphNodeModel methodsFor: 'menu' stamp: 'tg 9/8/2009 21:09'!
keyStroke: aCharacter from: aTreeMorph 
	^ false
! !

!GLMTreeMorphNodeModel methodsFor: 'menu' stamp: 'tg 1/17/2010 13:23'!
menu: aMenuMorph shifted: b 
	| subMenus targetMenuMorph subMenu |
	subMenus := Dictionary new.
	self containerTree allMenuActions do: [ :action |
		targetMenuMorph := action category notNil 
			ifTrue: [ subMenus at: action category ifAbsentPut: [ 
					subMenu :=  MenuMorph new.
					aMenuMorph add: action category subMenu: subMenu.
					subMenu ] ]
			ifFalse: [ aMenuMorph ].
		targetMenuMorph 
			add: action title
			target: self
			selector: #executeMenuAction:
			argument: action ].
	^ aMenuMorph! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'alain.plantec 9/8/2009 14:12'!
parentNode
	^ parentNode! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'alain.plantec 9/8/2009 14:12'!
parentNode: aNode
	parentNode := aNode
	! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 4/15/2010 00:24'!
path
	"returns the list of nodes to the root"
	^ self pathIn: OrderedCollection new.! !

!GLMTreeMorphNodeModel methodsFor: 'accessing' stamp: 'tg 9/10/2009 12:44'!
pathIn: aCollection 
	self parentNode ifNotNil: [
		(aCollection includes: self parentNode)
			ifFalse: [self parentNode pathIn: aCollection]].
	aCollection add: self.
	^ aCollection! !

!GLMTreeMorphNodeModel methodsFor: 'printing' stamp: 'tg 9/9/2009 13:30'!
printOn: aStream
	aStream nextPutAll: 'a NodeModel with '.
	aStream nextPutAll: self item printString.! !

!GLMTreeMorphNodeModel methodsFor: 'callbacks' stamp: 'tg 11/16/2009 06:46'!
rowMorphForColumn: aGlamourColumn
	^ (UITheme current
		newTextIn: World
		text: (self containerTree glamourPresentation column: aGlamourColumn valueFor: self item)) unlock; wrapFlag: true; yourself! !

!GLMTreeMorphNodeModel methodsFor: 'testing' stamp: 'tg 11/30/2009 02:10'!
shouldBeDisplayed
	^ self shouldBeDisplayedByTags and: [ self shouldBeDisplayedByText ]! !

!GLMTreeMorphNodeModel methodsFor: 'testing' stamp: 'tg 11/30/2009 02:15'!
shouldBeDisplayedByTags
	| nodeTags |
	self flag: 'it looks like this method does not really get called for children'.
"	self item mooseName = #'org::easymock' ifTrue: [self haltOnce ].
"	self containerTree tagsToFilterBy isEmpty ifTrue: [ ^ true ].
	self withContentsDo: [ :node | 
		nodeTags := self containerTree glamourPresentation tagsFor: node item to: #filter.
		(self containerTree tagsToFilterBy allSatisfy: [ :each | nodeTags includes: each ])
			ifTrue: [ ^ true ] ].
	^ false! !

!GLMTreeMorphNodeModel methodsFor: 'testing' stamp: 'tg 11/13/2009 02:10'!
shouldBeDisplayedByText
	self containerTree shouldFilterByTextInput ifFalse: [ ^ true ].
	self withContentsDo: 
		[ :node | 
		self flag: 'this should be delegated to the presentation
		and glamourValue should be used to include the entity ports'.
		(self containerTree glamourPresentation filterStrategy 
			value: self containerTree inputText asString
			value: node item) == true ifTrue: [ ^ true ] ].
	^ false! !

!GLMTreeMorphNodeModel methodsFor: 'callbacks' stamp: 'VeronicaUquillas 11/19/2009 22:44'!
tagsColumn 
	| tags |
	tags := (self containerTree glamourPresentation tagsFor: self item to: #show).
	tags isEmpty ifFalse: [
		^ self buttonForTag: tags last filter: tags last ].
	^ RectangleMorph new! !

!GLMTreeMorphNodeModel methodsFor: 'callbacks' stamp: 'tg 9/14/2009 23:33'!
toggleFilteringByTag: aTag 
	self containerTree toggleFilteringByTag: aTag! !

!GLMTreeMorphNodeModel methodsFor: 'enumerating' stamp: 'tg 9/9/2009 13:42'!
withContentsDo: aBlock
	self flag: 'if the tree is infinite due to recursion, this might not stop'.
	aBlock value: self.
	self contents do: [:each | each withContentsDo: aBlock ]! !

MorphTreeModel subclass: #GLMTreeMorphModel
	instanceVariableNames: 'roots glamourPresentation childrenBlock onSelection displayFormat tagsToFilterBy announcer inputText amountToFilterBy defaultPageSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMTreeMorphModel commentStamp: 'alain.plantec 9/8/2009 15:22' prior: 0!
ClassTree new openOn: Collection
!

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 11/6/2009 00:53'!
allKeystrokeActions
	^ self glamourPresentation allActions select: [:action | action hasShortcut ]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/10/2009 01:53'!
allMenuActions
	^ self glamourPresentation allActions select: [:action | action hasTitle ]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 1/18/2010 23:59'!
amountToFilterBy
	^ nil "amountToFilterBy ifNil: [self glamourPresentation amountToShow]"! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/30/2009 12:05'!
amountToFilterBy: aNumber 
	amountToFilterBy := aNumber! !

!GLMTreeMorphModel methodsFor: 'announcements' stamp: 'tg 9/11/2009 00:17'!
announce: anAnnouncement
	self announcer announce: anAnnouncement ! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 2/17/2010 23:05'!
announcer
	^ announcer ifNil: [announcer := GLMAnnouncer new]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 03:24'!
childrenBlock
	^ childrenBlock ifNil: [ childrenBlock := self glamourPresentation children isNil 
		ifFalse: [self glamourPresentation children] ifTrue: [OrderedCollection new] ]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 03:28'!
childrenBlock: aBlock
	childrenBlock := aBlock ! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 1/19/2010 00:12'!
defaultPageSize
	^ defaultPageSize! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 1/18/2010 23:54'!
defaultPageSize: anInteger
	defaultPageSize := anInteger! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 03:23'!
displayFormat
	^ displayFormat ifNil: [displayFormat := self glamourPresentation format]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/13/2009 03:28'!
displayFormat: aBlock 
	displayFormat := aBlock ! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'tg 9/28/2009 00:11'!
doSearchOrFilter
	inputText isEmptyOrNil
		ifTrue: [ self resetInput ]
		ifFalse:[ 
			self glamourPresentation allowsFilter 
				ifTrue: [ self executeFilter ]
				ifFalse: [ self executeSearch ] ].
! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'tg 9/28/2009 01:25'!
executeFilter
	self changed: #roots! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'tg 8/18/2010 16:38'!
executeSearch
	| newSelection check |
	newSelection := OrderedCollection new.
	roots do: [ :each | 
		check := self glamourPresentation searchStrategy value: self inputText value: each item.
		check ifTrue: [newSelection add: each path]].
	newSelection isEmpty 
		ifFalse: [ self selection: (MorphTreeMorphMultipleSelection new selectedNodePathList: newSelection) ]
		ifTrue: [self selection: nil]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 2/28/2010 21:28'!
explicitSelection: anObject 
	"anObject is a domain object, not a Glamour related object"
	self glamourPresentation isMultiple 
		ifTrue: [ self explicitlySelectMultipleItems: anObject ]
		ifFalse: [ self explicitlySelectItem: anObject ]! !

!GLMTreeMorphModel methodsFor: 'private selecting' stamp: 'tg 2/28/2010 21:28'!
explicitlySelectItem: anObject 
	(self selectedItem notNil and: [self selectedItem = anObject]) ifTrue: [ ^ self ].
	(self selectedItem isNil and: [ anObject isNil ]) ifTrue: [ ^ self ].
	anObject isNil ifTrue: [self selection: nil].
	self roots do: [:eachRoot |
		eachRoot withContentsDo: [:each |
			each item = anObject ifTrue: [
				each expandParentPath.
				self selectNodePath: each path.
				^ self]]]! !

!GLMTreeMorphModel methodsFor: 'private selecting' stamp: 'tg 1/11/2010 22:02'!
explicitlySelectMultipleItems: aCollection 
	| newSelection collection|
	aCollection isNil ifTrue: [^ self].
	collection := aCollection isCollection ifTrue: [aCollection] ifFalse: [aCollection asOrderedCollection ].
	(self selection notNil and: [
		self selection selectedItemOrItemsOrNil = collection asOrderedCollection ]) ifTrue: [ ^ self ].
	newSelection := OrderedCollection new.
	self roots do: [:eachRoot |
		eachRoot withContentsDo: [:each |
			(collection includes: each item) ifTrue: [
				newSelection add: each path ]]].
	self selectAllNodePaths: newSelection! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/30/2009 01:44'!
filteredRoots
	| filtered |
	roots ifNil: [ self roots: self glamourPresentation displayValue ].
	filtered := roots select: [ :each | each shouldBeDisplayed ].
	^ filtered! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 19:46'!
glamourPresentation
	^ glamourPresentation! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 19:46'!
glamourPresentation: anObject
	glamourPresentation := anObject! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/28/2009 01:24'!
inputText
	^ inputText ifNil: [inputText := '']! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/27/2009 23:05'!
inputText: anObject
	inputText := anObject.
	self doSearchOrFilter! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/27/2009 16:29'!
inputTextEnabled
	^ true! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 11/6/2009 00:58'!
keyStroke: aCharacter from: aTreeMorph 
	| action |
	action := self allKeystrokeActions detect: [:a | a shortcut = aCharacter] ifNone: [nil].
	action ifNotNil: [ self announce: (GLMKeyStroke action: action) ]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 11/29/2009 16:45'!
menu: menu shifted: b 
	"Set up the menu to apply to the receiver's, honoring the #shifted boolean"
	self selectedNode ifNotNil: [:current | current menu: menu shifted: b].
	^ menu! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 21:20'!
nodeModelFor: anObject
	^ (GLMTreeMorphNodeModel with: anObject) containerTree: self; yourself! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 12/29/2009 02:01'!
onDoubleClick
	self announcer announce: (GLMTreeMorphStrongSelectionChanged new strongSelectionValue: 
		(self selection ifNotNil: [self selection selectedItemOrItemsOrNil]))! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'tg 9/28/2009 00:11'!
resetInput
! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 9/14/2009 23:00'!
resetTagsToFilterBy
	tagsToFilterBy := OrderedCollection new.
	self changed: #roots.! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/30/2009 01:24'!
roots
	| filtered |
	roots ifNil: [ self roots: self glamourPresentation displayValue ].
	filtered := roots select: [ :each | each shouldBeDisplayed ].
	((self shouldFilterByAmount and: [
		self amountToFilterBy < filtered size]) and: [
			filtered notEmpty]) ifTrue: [
		filtered := filtered first: self amountToFilterBy ].
	^ filtered! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/8/2009 21:20'!
roots: anObjectOrCollection
	roots := anObjectOrCollection isCollection 
		ifTrue: [ anObjectOrCollection collect: [:each | self nodeModelFor: each ] ]
		ifFalse: [ OrderedCollection with: (self nodeModelFor: anObjectOrCollection) ]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 12/29/2009 01:57'!
selection: aSelection 
	self selection = aSelection ifTrue: [ ^ self ].
	super selection: aSelection.
	self announcer announce: (
			GLMTreeMorphSelectionChanged new 
				selectionValue: (aSelection ifNotNil: [aSelection selectedItemOrItemsOrNil]);
				selectionPathValue: self selectionPathItems;
				yourself)! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 11/29/2009 02:37'!
selectionPathItems
	^ self selectedNodePath isNil ifTrue: [nil] ifFalse: [self selectedNodePath collect: [:each | each item]]! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'tg 9/30/2009 14:01'!
shouldFilterByAmount
	^ self amountToFilterBy notNil and: [self amountToFilterBy isZero not]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 9/14/2009 23:29'!
shouldFilterByTag: aTag
	^ self tagsToFilterBy includes: aTag ! !

!GLMTreeMorphModel methodsFor: 'search and filtering' stamp: 'tg 11/13/2009 02:10'!
shouldFilterByTextInput
	^ self glamourPresentation allowsFilter and: [ self inputText notEmpty ]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 9/13/2009 03:59'!
tagsToFilterBy
	^ tagsToFilterBy ifNil: [ tagsToFilterBy := OrderedCollection new ]! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 9/30/2009 14:03'!
toggleAmountToFilterBy
	self amountToFilterBy notNil ifTrue: 
		[ self amountToFilterBy isZero 
			ifTrue: [ amountToFilterBy := self glamourPresentation amountToShow ]
			ifFalse: [ amountToFilterBy := 0 ].
		self changed: #roots ]! !

!GLMTreeMorphModel methodsFor: 'callbacks' stamp: 'tg 11/6/2009 01:19'!
toggleFilteringByTag: aTag 
	(self shouldFilterByTag: aTag) 
		ifTrue: [self tagsToFilterBy remove: aTag ]
		ifFalse: [self tagsToFilterBy add: aTag].
	self changed: #roots! !

!GLMTreeMorphModel methodsFor: 'accessing' stamp: 'tg 12/31/2009 03:45'!
updateRoots
	roots := nil.
	self changed: #roots! !

!GLMTreeMorphModel methodsFor: 'announcements' stamp: 'tg 9/11/2009 00:18'!
when: anAnnouncement do: aBlock
	self announcer when: anAnnouncement do: aBlock ! !

!ScrollBar methodsFor: '*Glamour-Morphic' stamp: 'tg 8/22/2010 20:27'!
glmAnimateValue: aNumber duration: anInteger
	aNumber = value ifTrue: [^ self ].
	anInteger <= 0 
		ifTrue: [ self setValue: aNumber ]
		ifFalse: [
			| startTime start end |
			startTime := Time millisecondClockValue.
			start := value roundTo: scrollDelta.
			[ | delta |
			[ (delta := Time millisecondClockValue - startTime) < anInteger ] whileTrue: [
				self setValue: (aNumber - start) * (delta / anInteger) + start.
				Processor yield ].
				self setValue: aNumber ]
					fork ]! !

RectangleMorph subclass: #GLMPaneScroller
	instanceVariableNames: 'sizing transform scrollBar paneCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:43'!
adjustPaneHeight
	"This gets called after the scrollbar has been shown or hidden, to move the bottom
	of the panes to the right place."
	
	transform bounds: self innerBounds.
	transform submorphsDo: [:m | m bounds: (m bounds withHeight: self paneHeight)]! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: ''!
adoptPaneColor: aColor
	super adoptPaneColor: aColor.
	scrollBar adoptPaneColor: aColor! !

!GLMPaneScroller methodsFor: 'private' stamp: 'jorge.ressia 5/25/2009 16:25'!
basicUpdateSizing
	sizing := (self paneCount min: self maxPanes) max: 1! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:21'!
bounds: aRectangle
	super bounds: aRectangle.
	self layoutWidgets.
	self layoutPanes.
	self setScrollDeltas.
! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:21'!
computeMorphWidths
	| paneWidths widths |
	paneWidths := self paneWidthsToFit: self totalPaneWidth.
	widths := OrderedCollection new.
	paneWidths do: [:w | widths add: w] separatedBy: [widths add: self separatorWidth].
	^ widths asArray
! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
hideOrShowScrollBar
	self isScrollable ifTrue: [self showScrollBar] ifFalse: [self hideScrollBar]! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
hideScrollBar
	self removeMorph: scrollBar.
	self adjustPaneHeight.! !

!GLMPaneScroller methodsFor: 'initialization' stamp: 'jorge.ressia 5/25/2009 16:29'!
initialize
	super initialize.
	self 
		color: Color white;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	self 
		initializeTransform;
		initializeScrollbar.
	paneCount := 0.! !

!GLMPaneScroller methodsFor: 'initialization' stamp: ''!
initializeScrollbar
	scrollBar := ScrollBar new model: self slotName: 'scrollBar'.
	scrollBar 
		borderWidth: 0;
		borderColor: #inset;
		height: self scrollBarHeight.
	self resizeScrollBar.
! !

!GLMPaneScroller methodsFor: 'initialization' stamp: 'david_roethlisberger 3/18/2009 14:26'!
initializeTransform
	transform := TransformMorph new.
	transform
		color: Color transparent;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		disableTableLayout;
		bounds: super innerBounds.
	self addMorphBack: transform.
! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:21'!
innerBounds
	| rect |
	rect := super innerBounds.
	^ self scrollBarIsVisible
		ifTrue: [rect withHeight: rect height - self scrollBarHeight - 1]
		ifFalse: [rect]! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
isScrollable
	^ self leftoverScrollRange > 0! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:21'!
layoutPanes
	| widths rect |
	widths := self computeMorphWidths.
	rect := 0@0 extent: (0 @ self paneHeight).
	transform submorphs 
					with: widths 
					do: [:m :w | 
						rect := rect withWidth: w.
						m bounds: rect.
						rect := rect translateBy: (w@0)]
						
! !

!GLMPaneScroller methodsFor: 'layout' stamp: ''!
layoutWidgets
	| inner outer |
	outer := super innerBounds.
	inner := self innerBounds.
	transform bounds: inner.
	scrollBar bounds: ((inner left @ inner bottom)
						corner: outer bottomRight)! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
leftoverScrollRange
	^ (self totalScrollRange - self innerBounds width roundTo: self scrollDeltaWidth) max: 0
! !

!GLMPaneScroller methodsFor: 'configuration' stamp: 'david_roethlisberger 3/18/2009 15:05'!
maxPanes
	^2! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'jorge.ressia 5/25/2009 16:18'!
paneCount
	^ paneCount! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:22'!
paneHeight
	^ transform bounds height! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:22'!
paneWidthsToFit: limit
	| padded |
	padded := Array new: self paneCount.
	padded atAllPut: (limit / self sizing) floor.
	(1 to: limit - padded sum) do: [:i | padded at: i put: (padded at: i) + 1].
	^ padded
	
	! !

!GLMPaneScroller methodsFor: 'panes' stamp: 'tg 8/22/2010 22:40'!
popAndReplacePane: aMorph	
	transform removeMorph: transform lastSubmorph. "one for the separator"
	transform submorphs isEmpty
		ifFalse: [ transform removeMorph: transform lastSubmorph ].
	paneCount := paneCount - 1.	
	
	aMorph 
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0.
	transform hasSubmorphs 
		ifTrue: [ transform addMorphBack: self separator ].
	transform addMorphBack: (aMorph adoptPaneColor: self paneColor).
	paneCount := paneCount + 1.
	self updatePanes! !

!GLMPaneScroller methodsFor: 'panes' stamp: ''!
popPane
	transform removeMorph: transform lastSubmorph. "one for the separator"
	transform submorphs isEmpty
		ifFalse: [ transform removeMorph: transform lastSubmorph ].
	paneCount := paneCount - 1.
	self updatePanes.! !

!GLMPaneScroller methodsFor: 'panes' stamp: ''!
pushPane: aMorph	
	aMorph 
		borderWidth: 0;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0.
	transform hasSubmorphs 
		ifTrue: [ transform addMorphBack: self separator ].
	transform addMorphBack: (aMorph adoptPaneColor: self paneColor).
	paneCount := paneCount + 1.
	self updatePanes! !

!GLMPaneScroller methodsFor: 'layout' stamp: ''!
resizeScrollBar
	| inner outer |
	outer := super innerBounds.
	inner := outer withHeight: outer height - self scrollBarHeight.
	scrollBar bounds: ((inner left @ inner bottom) corner: outer bottomRight)! !

!GLMPaneScroller methodsFor: 'layout' stamp: ''!
scrollBarHeight
	^ self theme scrollbarThickness! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
scrollBarIsVisible
	^ submorphs includes: scrollBar! !

!GLMPaneScroller methodsFor: 'input events' stamp: ''!
scrollBarMenuButtonPressed: anObject! !

!GLMPaneScroller methodsFor: 'updating' stamp: 'david_roethlisberger 3/18/2009 14:27'!
scrollBarValue: value
	transform hasSubmorphs ifFalse: [^ self].
	transform offset: (self leftoverScrollRange * value) rounded @ 0.! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:25'!
scrollDeltaWidth
	^ 1! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'tg 8/22/2010 20:38'!
scrollToRight
"	(transform submorphs size + 1) / 2 > paneCount ifTrue: [ 
"		scrollBar glmAnimateValue: 1.0 duration: 200 "]"! !

!GLMPaneScroller methodsFor: 'panes' stamp: ''!
separator
	^ BorderedSubpaneDividerMorph vertical
		adoptPaneColor: self paneColor;
		yourself! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:28'!
separatorWidth
	^3! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:26'!
setScrollDeltas
	| range interval value |
	transform hasSubmorphs ifFalse: [scrollBar interval: 1.0. ^ self].
	range := self leftoverScrollRange.
	range = 0 ifTrue: [^ scrollBar interval: 1.0; setValue: 0].
	interval := ((self innerBounds width) / self totalScrollRange) asFloat.
	value := (transform offset x / range min: 1.0) asFloat.
	scrollBar interval: interval.
	scrollBar setValue: value.! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:26'!
showScrollBar
	self scrollBarIsVisible ifTrue: [^ self].
	self resizeScrollBar.
	self addMorphFront: scrollBar.
	self adjustPaneHeight.
	! !

!GLMPaneScroller methodsFor: 'accessing' stamp: 'david_roethlisberger 3/18/2009 14:27'!
sizing
	^ sizing ifNil: [self updateSizing]! !

!GLMPaneScroller methodsFor: 'layout' stamp: 'david_roethlisberger 3/18/2009 14:22'!
totalPaneWidth
	^ self innerBounds width - ((self sizing - 1) * self separatorWidth)! !

!GLMPaneScroller methodsFor: 'scrolling' stamp: 'david_roethlisberger 3/18/2009 14:26'!
totalScrollRange
	| submorphBounds |
	submorphBounds := transform localSubmorphBounds ifNil: [^ 0].
	^ submorphBounds width
! !

!GLMPaneScroller methodsFor: 'updating' stamp: 'jorge.ressia 5/25/2009 16:40'!
updatePanes
	self basicUpdateSizing.
	self layoutPanes.
	self hideOrShowScrollBar.
	self setScrollDeltas.
	self scrollToRight! !

!GLMPaneScroller methodsFor: 'updating' stamp: 'david_roethlisberger 3/18/2009 14:27'!
updateSizing
	| old |
	old := sizing.
	self basicUpdateSizing.
	sizing = old ifFalse: [self layoutPanes].
	^sizing! !

Announcer subclass: #GLMMorphicModel
	instanceVariableNames: 'glamourPresentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

GLMMorphicModel subclass: #GLMButtonModel
	instanceVariableNames: 'glamourAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMButtonModel methodsFor: 'actions' stamp: 'tg 11/8/2009 21:25'!
buttonLabel
	^ self glamourAction title! !

!GLMButtonModel methodsFor: 'actions' stamp: 'tg 11/8/2009 21:35'!
execute
	self glamourAction actOn: self glamourPresentation! !

!GLMButtonModel methodsFor: 'accessing' stamp: 'tg 11/8/2009 21:24'!
glamourAction
	^ glamourAction! !

!GLMButtonModel methodsFor: 'accessing' stamp: 'tg 11/8/2009 21:24'!
glamourAction: anObject
	glamourAction := anObject! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'tg 8/4/2009 15:26'!
allKeystrokeActions
	^ self glamourPresentation allActions select: [:action | action hasShortcut ]! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'tg 8/4/2009 15:24'!
allMenuActions
	^ self glamourPresentation allActions select: [:action | action hasTitle ]! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'jre 7/31/2009 09:48'!
executeMenuAction: anAction
	self announce: (GLMMenuItemSelected action: anAction)! !

!GLMMorphicModel methodsFor: 'accessing' stamp: 'tg 8/4/2009 14:23'!
glamourPresentation
	^ glamourPresentation! !

!GLMMorphicModel methodsFor: 'accessing' stamp: 'tg 8/4/2009 14:23'!
glamourPresentation: anObject
	glamourPresentation := anObject! !

!GLMMorphicModel methodsFor: 'initialization' stamp: 'tg 8/4/2009 15:26'!
initialize
	super initialize.! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'tg 8/4/2009 15:26'!
keystroke: aChar from: aMorph
	| action |
	action := self allKeystrokeActions detect: [:a | a shortcut = aChar] ifNone: [nil].
	action ifNotNil: [ self announce: (GLMKeyStroke action: action) ].! !

!GLMMorphicModel methodsFor: 'callbacks' stamp: 'tg 9/8/2009 14:46'!
menu: aMenuMorph 
	| subMenus targetMenuMorph subMenu |
	subMenus := Dictionary new.
	self allMenuActions do: [ :action |
		targetMenuMorph := action category notNil 
			ifTrue: [ subMenus at: action category ifAbsentPut: [ 
					subMenu :=  MenuMorph new.
					aMenuMorph add: action category subMenu: subMenu.
					subMenu ] ]
			ifFalse: [ aMenuMorph ].
		targetMenuMorph 
			add: action title
			target: self
			selector: #executeMenuAction:
			argument: action ].
	^ aMenuMorph! !

GLMMorphicModel subclass: #GLMTextModel
	instanceVariableNames: 'text highlightSmalltalk highlightSmalltalkContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMTextModel methodsFor: 'callbacks' stamp: 'tg 11/12/2009 23:02'!
accept: aText notifying: anObject 
	aText asString withBlanksTrimmed ifEmpty: [^self].
	self text: aText.
	self changed: #text! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:04'!
highlightSmalltalk
	^ highlightSmalltalk! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:04'!
highlightSmalltalk: anObject
	highlightSmalltalk := anObject! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:06'!
highlightSmalltalkContext
	^ highlightSmalltalkContext! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:06'!
highlightSmalltalkContext: anObject
	highlightSmalltalkContext := anObject! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'tg 11/12/2009 22:58'!
keystroke: anEvent from: aMorph
	anEvent anyModifierKeyPressed ifTrue: [ super keystroke: anEvent keyCharacter from: aMorph ].
	self glamourPresentation text: self text.
! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'tg 8/4/2009 15:31'!
menu: aMorphMenu shifted: b
	^ self menu: aMorphMenu! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'tg 5/14/2009 22:10'!
selectSilently: anIndex
	self changed: #selection! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'tg 8/22/2010 13:14'!
selection
	^ self glamourPresentation selectionInterval ifNil: [1 to: 0]! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:42'!
shoutAboutToStyle: aPluggableShoutMorph
	self highlightSmalltalk ifFalse: [^ false].
	self highlightSmalltalkContext notNil ifTrue: [
		aPluggableShoutMorph classOrMetaClass: self highlightSmalltalkContext].
	^ true! !

!GLMTextModel methodsFor: 'callbacks' stamp: 'david_roethlisberger 2/27/2009 11:50'!
text
	^text! !

!GLMTextModel methodsFor: 'accessing' stamp: 'tg 11/12/2009 23:04'!
text: aTextOrString
	text := aTextOrString.
	self glamourPresentation ifNotNil: [ :presentation | presentation text: text ]! !

ScrollPane subclass: #GLMScrollPaneForHResize
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMScrollPaneForHResize commentStamp: 'tg 10/2/2009 00:42' prior: 0!
This class has no implementation. It is only useful for identifying the scroll panes that need to resize the content horizontally (to stretch their size), like in the case of the magritte forms. It is instantiated in the MorhpicRenderer and queried for in the GlamorousSystemWindow.!

Object subclass: #GLMDropListModel
	instanceVariableNames: 'list selectionIndex announcer glamourPresentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/18/2010 15:55'!
announcer
	^ announcer ifNil: [announcer := GLMAnnouncer new]! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/18/2010 16:33'!
glamourPresentation

	^glamourPresentation! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/18/2010 16:33'!
glamourPresentation: anObject
	glamourPresentation := anObject! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/27/2010 17:34'!
list
	
	^list ifNil: [ list:= (self glamourPresentation displayValue 
									collect:[ :each| (self glamourPresentation formatedDisplayValueOf: each) asMorph ])]! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/18/2010 15:53'!
list: anObject
	list := anObject! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/27/2010 17:48'!
selectedItem
	"Answer the currently selected item or nil if none."

	^self selectionIndex = 0
		ifTrue: [nil]
		ifFalse: [self glamourPresentation displayValue at: self selectionIndex]! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/26/2010 14:45'!
selectionIndex

	^ selectionIndex ifNil:[ selectionIndex:= self glamourPresentation selectedIndex ]! !

!GLMDropListModel methodsFor: 'accessing' stamp: 'VeronicaUquillas 5/27/2010 17:49'!
selectionIndex: anObject
	selectionIndex := anObject.
	self announcer announce: (
			GLMDropDownListMorphSelectionChanged new 
				selectionValue: self selectedItem
				yourself)! !

Object subclass: #GLMMorphic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphic classSide methodsFor: 'as yet unclassified' stamp: 'VeronicaUquillas 6/15/2010 10:33'!
alignmentMorph: aCollectionOfMorphs
	"Answer a row-oriented AlignmentMorph holding the given collection"
	| morph |

	morph:= AlignmentMorph new
		listDirection: #leftToRight;
		borderWidth: 0;
		color: Color transparent;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		layoutInset: 1;
		wrapCentering: #center;
		cellPositioning: #center.
	aCollectionOfMorphs do: [ :each | morph addMorphBack: each].
	^morph! !

!GLMMorphic classSide methodsFor: 'as yet unclassified' stamp: 'tg 1/7/2010 00:49'!
emptyMorph
	^ PanelMorph new
		layoutPolicy: ProportionalLayout new;
		color: Color transparent;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		borderWidth: 0;
		yourself! !

!GLMMorphic classSide methodsFor: 'as yet unclassified' stamp: 'tg 1/13/2010 23:01'!
emptyMorphShowing: aBoolean asTitle: aTitle
	^ aBoolean 
		ifTrue: [
			GroupboxMorph new
				label: aTitle;
				layoutPolicy: ProportionalLayout new;
				color: Color transparent;
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				borderWidth: 0;
				yourself]
		ifFalse: [ self emptyMorph ]! !

!GLMMorphic classSide methodsFor: 'button styles' stamp: 'VeronicaUquillas 6/15/2010 10:44'!
grayRoundedButtonStyle: button morph: aMorph pressed: aBoolean

	button useRoundedCorners.
	(self isAlignmentMorph: aMorph)
	ifTrue:[ 
		aBoolean 
		ifTrue: [ aMorph lastSubmorph color: Color darkGray.
					button color: Color veryLightGray ]
		ifFalse:[ aMorph lastSubmorph color: Color white.
					button color: Color gray ] ]
	ifFalse:[			
		aBoolean 
		ifTrue: [ aMorph color: Color darkGray.
				   button color: Color veryLightGray ]
		ifFalse:[ aMorph color: Color white.
					button color: Color gray ] ]
! !

!GLMMorphic classSide methodsFor: 'as yet unclassified' stamp: 'VeronicaUquillas 11/19/2009 20:08'!
isAlignmentMorph: anObject

	^anObject isMemberOf: AlignmentMorph! !

!GLMMorphic classSide methodsFor: 'button styles' stamp: 'VeronicaUquillas 6/15/2010 10:49'!
isGrayRoundedButton: aSymbol

	^aSymbol = #grayRoundedButton
		or:[ aSymbol = #default ]! !

!GLMMorphic classSide methodsFor: 'as yet unclassified' stamp: 'VeronicaUquillas 11/19/2009 20:08'!
isImageMorph: anObject

	^anObject isMemberOf: ImageMorph! !

!GLMMorphic classSide methodsFor: 'button styles' stamp: 'VeronicaUquillas 6/15/2010 11:14'!
isWhiteRectangledButton: aSymbol

	^aSymbol = #whiteRectangledButton! !

!GLMMorphic classSide methodsFor: 'as yet unclassified' stamp: 'VeronicaUquillas 11/20/2009 11:20'!
morphElement: anObject

	anObject isString
	ifTrue:[ ^StringMorph 
					contents: anObject 
					font: (LogicalFont 
						familyName: UITheme current buttonFont familyName
						pointSize: UITheme current buttonFont pointSize - 2) ].
	
	anObject isCollection 
	ifTrue: [ |row|
				row:= OrderedCollection new.
				anObject do: [ :e| row add: (self morphElement: e) ].
				^self alignmentMorph: row ].
				
	anObject isForm
	ifTrue:[ ^ImageMorph new newForm: anObject ].
	
	^self emptyMorph! !

!GLMMorphic classSide methodsFor: 'as yet unclassified' stamp: 'VeronicaUquillas 6/15/2010 11:02'!
styleButton: button morph: m pressed: aBoolean style: aSymbol

	(self isGrayRoundedButton: aSymbol)
	ifTrue:[ self grayRoundedButtonStyle: button morph: m pressed: aBoolean ].
	
	(self isWhiteRectangledButton: aSymbol)
	ifTrue:[ self whiteRectangledButtonStyle: button morph: m pressed: aBoolean ]! !

!GLMMorphic classSide methodsFor: 'as yet unclassified' stamp: 'VeronicaUquillas 6/15/2010 11:29'!
togglingButtonLabelled: anObject pressed: aBoolean style: aSymbol
	| button oldLabel m |
	button := SimpleButtonMorph new.
	(oldLabel := button findA: StringMorph) ifNotNil: [ oldLabel delete ].
	m := self morphElement: anObject.
	
	button
		addMorph: m;
		borderStyle: (BorderStyle inset width: 1);
		borderColor: Color gray.

	(self isAlignmentMorph: m)
	ifTrue:[ 
		button extent: m width @ (m height - 2).
		m position: 0 @ -2 ]
	ifFalse:[ 
		(self isImageMorph: m)
		ifTrue: [ button borderColor: Color transparent.
					button extent: (m width + 6) @ m height ]
		ifFalse:[ button extent: (m width + 6) @ (m height + 2) ].
		m position: 3 @ 0.	"button center - (m extent // 2)" ].
		
	self styleButton: button morph: m pressed: aBoolean style: aSymbol.
	m lock.
	
	^ button! !

!GLMMorphic classSide methodsFor: 'button styles' stamp: 'VeronicaUquillas 6/15/2010 10:58'!
whiteRectangledButtonStyle: button morph: aMorph pressed: aBoolean

	button useSquareCorners.
	(self isAlignmentMorph: aMorph)
	ifTrue:[ 
		aBoolean 
		ifTrue: [ aMorph lastSubmorph color: Color white.
					button color: Color gray ]
		ifFalse:[ aMorph lastSubmorph color: Color black.
					button color: Color white ] ]
	ifFalse:[			
		aBoolean 
		ifTrue: [ aMorph color: Color white.
				   button color: Color gray ]
		ifFalse:[ aMorph color: Color black.
					button color: Color white ] ]! !

Object subclass: #GLMMorphicWidgetRenderer
	instanceVariableNames: 'renderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphicWidgetRenderer commentStamp: '<historical>' prior: 0!
This is a helper class that is supposed to be subclassed for each rendering logic of a specific morph. For example, there will be a TreeRenderer, a TextRenderer etc!

GLMMorphicWidgetRenderer subclass: #GLMMorphicBrowserRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

GLMMorphicBrowserRenderer subclass: #GLMMorphicAccumulatorRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphicAccumulatorRenderer methodsFor: 'rendering' stamp: 'tg 8/23/2010 00:38'!
render: aBrowser

	| tabs |
	aBrowser panes isEmpty ifTrue: [ ^ GLMMorphic emptyMorph ].
"	presentations size = 1 ifTrue: [ 
		^ self morph: (self render: presentations first) withTitleOrNilOf: aCompositePresentation ].
"	tabs := LazyTabGroupMorph new.
	tabs
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		cornerStyle: (self theme tabGroupCornerStyleIn: nil);
		font: self theme labelFont;
		onPageIndexChange: [ :i | 
			aBrowser activeEntity: ((aBrowser panes at: i) port: #entity) value ].
	aBrowser panes do: [ :each | 
		tabs 
			addLazyPage: [ self renderPaneWithoutTitle: each ]
			label: (self titleOrIconOf: each presentations in: tabs) ].
	aBrowser 
		when: GLMPaneSelected
		do: [ :ann | 
			tabs selectedPageIndex: ann position ].
	aBrowser 
		when: GLMPaneAdded
		do: [ :ann | 
			tabs addLazyPage: (self renderPaneWithoutTitle: ann pane) label: (self titleOrIconOf: ann pane presentations in: tabs).
			tabs selectedPageIndex: tabs lazyPages size ].
	tabs selectedPageIndex: tabs lazyPages size.
	^ tabs! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicFinderRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphicFinderRenderer methodsFor: 'rendering' stamp: 'tg 8/22/2010 23:49'!
render: aBrowser
	| container |
	container := GLMPaneScroller new
		name: 'scroller';
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		yourself.
	aBrowser 
		when: GLMPaneRemoved
		do: [ :ann | container popPane.].
	aBrowser 
		when: GLMPaneAdded
		do: [ :ann | container pushPane: (self renderObject: ann pane) ].
	aBrowser 
		when: GLMPaneReplaced
		do: [ :ann | 
			container popAndReplacePane: (self renderObject: ann newPane) ].
	aBrowser panes
		do: [ :each | container pushPane: (self renderObject: each) ].
	^ container! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicStackerRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphicStackerRenderer methodsFor: 'rendering' stamp: 'tg 8/23/2010 00:44'!
render: aBrowser
	| tabs |
	aBrowser panes isEmpty ifTrue: [ ^ GLMMorphic emptyMorph ].
	tabs := LazyTabGroupMorph new.
	tabs
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		cornerStyle: (self theme tabGroupCornerStyleIn: nil);
		font: self theme labelFont.
	aBrowser panes do: [ :each | 
		tabs 
			addLazyPage: [ self renderPaneWithoutTitle: each ]
			label: (self titleOrIconOf: each presentations in: tabs) ].
	tabs selectedPageIndex: 1.
	^ tabs! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicTabulatorRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphicTabulatorRenderer methodsFor: 'rendering' stamp: 'tg 8/22/2010 23:43'!
render: aBrowser
	| container |
	container := GLMMorphic emptyMorph.
	aBrowser cell isRow 
		ifTrue: 
			[ self 
				renderCustomRow: aBrowser cell
				ofPane: aBrowser pane
				inUI: container
				inBrowser: aBrowser ]
		ifFalse: 
			[ self 
				renderCustomColumn: aBrowser cell
				ofPane: aBrowser pane
				inUI: container
				inBrowser: aBrowser ].

	^ container! !

!GLMMorphicTabulatorRenderer methodsFor: 'private' stamp: 'tg 8/22/2010 23:45'!
renderCustomColumn: aCell ofPane: aPane inUI: aMorph inBrowser: aBrowser 
	| pane totalSpans currentSpanPosition currentOffset |
	totalSpans := aCell children inject: 0 into: [ :sum :each | sum + each span ].
	currentSpanPosition := 0.
	currentOffset := 0.
	aCell children keysAndValuesDo: [ :index :each | 
		each hasId 
			ifTrue: [ pane := self renderObject: (aBrowser paneNamed: each id) ]
			ifFalse: [ 
				self 
					renderCustomRow: each
					ofPane: aPane
					inUI: (pane := GLMMorphic emptyMorph)
					inBrowser: aBrowser.
				pane addPaneSplitters ].
		pane layoutFrame: (LayoutFrame new
					topFraction: currentSpanPosition / totalSpans offset: currentOffset + 2;
					leftFraction: 0 offset: 0;
					bottomFraction: (currentSpanPosition + each span) / totalSpans offset: currentOffset + each size - 2;
					rightFraction: 1 offset: 0;
					yourself).
		aMorph addMorphBack: pane.
		currentSpanPosition := currentSpanPosition + each span.
		currentOffset := currentOffset + each size ].
	(aCell children last size > 0) ifTrue: [
		(aMorph submorphs atLast: 2) layoutFrame bottomOffset: (aMorph submorphs atLast: 2) layoutFrame bottomOffset - aCell children last size. 
		aMorph submorphs last layoutFrame topOffset: aMorph submorphs last layoutFrame topOffset - aCell children last size. 
		aMorph submorphs last layoutFrame bottomOffset: aMorph submorphs last layoutFrame bottomOffset - aCell children last size.].
	aMorph addPaneSplitters! !

!GLMMorphicTabulatorRenderer methodsFor: 'private' stamp: 'tg 8/22/2010 23:45'!
renderCustomRow: aCell ofPane: aPane inUI: aMorph inBrowser: aBrowser 
	| pane totalSpans currentSpanPosition currentOffset |
	totalSpans := aCell children inject: 0 into: [ :sum :each | sum + each span ].
	currentSpanPosition := 0.
	currentOffset := 0.
	aCell children keysAndValuesDo: [ :index :each | 
		each hasId 
			ifTrue: [ pane := self renderObject: (aBrowser paneNamed: each id) ]
			ifFalse: [ self 
					renderCustomColumn: each
					ofPane: aPane
					inUI: (pane := GLMMorphic emptyMorph)
					inBrowser: aBrowser.
				pane addPaneSplitters ].
		pane layoutFrame: (LayoutFrame new
				topFraction: 0 offset: 0;
				leftFraction: currentSpanPosition / totalSpans offset: currentOffset + 2;
				bottomFraction: 1 offset: 0;
				rightFraction: (currentSpanPosition + each span) / totalSpans offset: currentOffset + each size - 2;
				yourself).
		aMorph addMorphBack: pane.
		currentSpanPosition := currentSpanPosition + each span.
		currentOffset := currentOffset + each size ].
	(aCell children last size > 0) ifTrue: [
		(aMorph submorphs atLast: 2) layoutFrame rightOffset: (aMorph submorphs atLast: 2) layoutFrame rightOffset - aCell children last size. 
		aMorph submorphs last layoutFrame leftOffset: aMorph submorphs last layoutFrame leftOffset - aCell children last size. 
		aMorph submorphs last layoutFrame rightOffset: aMorph submorphs last layoutFrame rightOffset - aCell children last size.].
	aMorph addPaneSplitters! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicCompositeRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

GLMMorphicCompositeRenderer subclass: #GLMMorphicAccordionRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphicAccordionRenderer methodsFor: 'rendering' stamp: 'tg 8/23/2010 00:26'!
render: aPresentation
	| presentations container expander |
	presentations := aPresentation matchingPresentations.
	presentations isEmpty ifTrue: [ ^ GLMMorphic emptyMorph ].
	presentations size = 1 ifTrue: [ ^ self renderObject: presentations first ].
	container := GLMMorphic emptyMorph.
	container changeTableLayout.
	presentations do: [ :each | 
		expander := self theme 
			newExpanderIn: container 
			label: (self titleOrIconOf: each in: container)
			forAll: {(self renderObject: each)}.
		container addMorphBack: expander.
		(aPresentation pane lastActivePresentation notNil and: [
			each title = aPresentation pane lastActivePresentation title ]) ifTrue: [
				expander expanded: true]].
	(aPresentation pane lastActivePresentation isNil and: [container submorphs notEmpty]) ifTrue: [
		container submorphs first expanded: true].
	^ container! !

GLMMorphicCompositeRenderer subclass: #GLMMorphicTabbedRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphicTabbedRenderer methodsFor: 'rendering' stamp: 'tg 8/23/2010 00:27'!
render: aPresentation

	| presentations tabs index |
	presentations := aPresentation matchingPresentations.
	presentations isEmpty ifTrue: [ ^ GLMMorphic emptyMorph ].
	(presentations size = 1 and:[ presentations first hasTitleIcon not ])
	ifTrue: [ ^ self renderWithTitleOrNil: presentations first ].
	tabs := LazyTabGroupMorph new.
	tabs
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		cornerStyle: (self theme tabGroupCornerStyleIn: nil);
		font: self theme labelFont;
		onPageIndexChange: [ :i | 
			aPresentation pane lastActivePresentation: (aPresentation matchingPresentations at: i) ].
	presentations do: [ :each | 
		tabs 
			addLazyPage: [ self renderObject: each ]
			label: (self titleOrIconOf: each in: tabs) ].
	index := 1.
	presentations withIndexDo: [ :each :i | 
		aPresentation pane lastActivePresentation notNil and: [ 
			each title = aPresentation pane lastActivePresentation title ifTrue: [ 
				index := i ] ] ].
	tabs selectedPageIndex: index.
	aPresentation when: GLMPresentationUpdated do: [:ann |
		tabs clear.	
		presentations do: [ :each | 
			tabs 
				addLazyPage: [ self renderObject: each ]
				label: (self titleOrIconOf: each in: tabs) ].
			index := 1.
			presentations withIndexDo: [ :each :i | 
				aPresentation pane lastActivePresentation notNil and: [ 
					each title = aPresentation pane lastActivePresentation title ifTrue: [ 
						index := i ] ] ].
		tabs selectedPageIndex: index.].

	^ tabs! !

GLMMorphicCompositeRenderer subclass: #GLMMorphicVerticallyStackedRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphicVerticallyStackedRenderer methodsFor: 'rendering' stamp: 'tg 8/23/2010 00:27'!
render: aPresentation
	| presentations container |
	presentations := aPresentation matchingPresentations.
	presentations isEmpty ifTrue: [ ^ GLMMorphic emptyMorph ].	
	container := GLMMorphic emptyMorph.
	container changeTableLayout.
	presentations do: [ :each | 
		container addMorphBack: (self renderWithTitle: each) ].
	^ container! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicDiffRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphicDiffRenderer methodsFor: 'rendering' stamp: 'tg 8/22/2010 23:21'!
render: aPresentation
	| textMorph |
	textMorph := (DiffMorph from: aPresentation displayValue first to: aPresentation displayValue last)
"			onKeyStrokeSend: #keystroke:from: to: textModel;
"			layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			color: Color white;
			yourself.
"	self installActionsOnUI: textModel fromPresentation: aTextPresentation.
	aTextPresentation selectedTextBlock: [ textMorph textMorph editor selection ].
	aTextPresentation textBlock: [ textMorph textMorph editor text ].
"	^textMorph! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicListingRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

GLMMorphicListingRenderer subclass: #GLMMorphicListRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphicListingRenderer methodsFor: 'rendering' stamp: 'tg 8/23/2010 00:28'!
render: aPresentation
	| treeModel container treeMorph textInput |
	treeModel := GLMTreeMorphModel new glamourPresentation: aPresentation.
	container := GLMMorphic emptyMorph.
	treeMorph := self treeMorphFor: treeModel and: aPresentation.
	aPresentation allowsInput ifTrue: [
		textInput := self textInputFor: treeModel.
		treeMorph layoutFrame bottomOffset: -24.
		container addMorphBack: textInput ].
	container addMorphBack: treeMorph.
	self installActionsOnUI: treeModel fromPresentation: aPresentation.

	"When the morph changes, we want to update the glamour model"
	treeModel announcer on: GLMTreeMorphSelectionChanged do: [ :ann | 
		aPresentation announcer suspendAllWhile: [
			aPresentation selection: ann selectionValue.
			aPresentation selectionPath: ann selectionPathValue] ].
	treeModel announcer on: GLMTreeMorphStrongSelectionChanged do: [ :ann | 
		aPresentation strongSelection: ann strongSelectionValue ].
	
	"When the glamour model changes, we want to update the morph"
	aPresentation when: GLMContextChanged do: [ :ann | 
			ann property = #selection ifTrue: [ 
				treeModel announcer suspendAllWhile: [
					treeMorph model explicitSelection: ann value ] ] ].
	aPresentation when: GLMPresentationUpdated do: [ :ann |
		treeMorph model updateRoots ].

	^ container! !

!GLMMorphicListingRenderer methodsFor: 'private' stamp: 'tg 8/23/2010 00:59'!
textInputFor: treeModel
	| textInput |
	textInput := self theme 
			newTextEntryIn: nil
			for: treeModel
			get: #inputText
			set: #inputText:
			class: String
			getEnabled: #inputTextEnabled
			help: 'Search Input'.
	textInput layoutFrame: (LayoutFrame 
				fractions: (0 @ 1 corner: 1 @ 1)
				offsets: (0 @ -24 corner: 0 @ 0)).
	^ textInput! !

!GLMMorphicListingRenderer methodsFor: 'private' stamp: 'tg 8/23/2010 00:57'!
treeMorphFor: treeModel and: aPresentation
	| treeMorph columns |
	treeMorph := LazyMorphTreeMorph new.
	treeMorph
		makeLastColumnUnbounded;
		doubleClickSelector: #onDoubleClick;
		getMenuSelector: #menu:shifted:;
		keystrokeActionSelector: #keyStroke:from:;
		cornerStyle: treeMorph preferredCornerStyle;
		borderStyle: (BorderStyle inset width: 1);
		autoDeselection: aPresentation allowsDeselection;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1)).
	columns := aPresentation columns isEmpty 
		ifTrue: [ OrderedCollection with: (MorphTreeColumn new rowMorphGetSelector: #elementColumn)]
		ifFalse: [
			aPresentation columns collect: [:each | 
				GLMMorphTreeColumn new 
					glamourColumn: each; 
					headerButtonLabel: (aPresentation titleValueOfColumn: each) 
					font: Preferences standardMenuFont 
					target: nil 
					actionSelector: nil 
					arguments: #(); 
					yourself ].
		].
	treeMorph
		preferedPaneColor: Color white;	
		model: treeModel;
		nodeListSelector: #roots;
		columns: columns.
	aPresentation isMultiple 
		ifTrue: [treeMorph beMultiple] 
		ifFalse: [treeMorph beSingle].
	treeModel chunkSize: aPresentation amountToShow.
	treeMorph vShowScrollBar.
	^ treeMorph buildContents! !

GLMMorphicListingRenderer subclass: #GLMMorphicTableRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

GLMMorphicListingRenderer subclass: #GLMMorphicTreeRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphicTreeRenderer methodsFor: 'rendering' stamp: 'tg 8/22/2010 23:18'!
render: aPresentation
	| container |
	container := super render: aPresentation.
	aPresentation shouldAllExpand ifTrue: [container submorphs first expandAll ].
	aPresentation shouldRootsExpand ifTrue: [container submorphs first expandRoots ].
	^ container! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicMondrianRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphicMondrianRenderer methodsFor: 'private' stamp: 'AlexandreBergel 9/6/2010 10:36'!
mondrianCanvasFor: aPresentation in: aScrollPane 
	| canvas view |
	view := aPresentation view.
	view root interaction menu: [ :x | self menuIn: MenuMorph new for: aPresentation ].
	aPresentation renderOn: view.
	canvas := MOCanvas new.
	canvas root: view root.
	canvas initializeHanders.
	canvas announcer
			when: MOElementSelection
			do: [ :ann | aPresentation selection: ann element model ].
	canvas announcer
			when: MOMouseEnter
			do: [ :ann | aPresentation status: ann element model ].
	canvas announcer
			when: MOMouseLeave
			do: [ :ann | aPresentation status: nil ].
	aPresentation when: GLMPresentationUpdated do: [:ann |
		aPresentation view: MOViewRenderer new.
		aScrollPane scroller removeMorph: aScrollPane scroller submorphs first.
		self mondrianCanvasFor: aPresentation in: aScrollPane ].
	aPresentation when: GLMContextChanged do: [ :ann | 
			ann property = #selection ifTrue: [ 
				canvas selected: (canvas root deepFindNodeWithEntity: ann value) ] ].
	aScrollPane scroller addMorph: canvas.	

	^ canvas! !

!GLMMorphicMondrianRenderer methodsFor: 'rendering' stamp: 'tg 8/23/2010 00:22'!
render: aPresentation
	| canvasScrollPane |
	canvasScrollPane := ScrollPane new.
	self mondrianCanvasFor: aPresentation  in: canvasScrollPane.
	canvasScrollPane
		color: Color white;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	^ canvasScrollPane! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicPaneRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphicPaneRenderer methodsFor: 'rendering' stamp: 'tg 8/23/2010 00:33'!
render: aPane
	| container |
	container := GLMMorphic emptyMorph.
	aPane when: GLMMatchingPresentationsChanged do: [ :ann | 
		container
			removeAllMorphs;
			addMorph: (self renderWithTitleOrNil: aPane presentations)
			fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
			adoptPaneColor: container paneColor.
		renderer window fullBounds.
		renderer window refreshHorizontalScollbars ].
	container
		addMorph: (self renderWithTitleOrNil: aPane presentations)
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
		adoptPaneColor: container paneColor.
	^ container! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicTextRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphicTextRenderer methodsFor: 'rendering' stamp: 'tg 8/23/2010 00:39'!
render: aPresentation
	| textMorph toShow textModel | 
	toShow := aPresentation formatedDisplayValue. 
	textModel := GLMTextModel new
			text: toShow;
			glamourPresentation: aPresentation;
			highlightSmalltalk: aPresentation highlightSmalltalk;
			highlightSmalltalkContext: aPresentation highlightSmalltalkContext.
	textMorph := (PluggableShoutMorph
		on: textModel
		text: #text
		accept: #accept:notifying:
		readSelection: #selection
		menu: #menu:shifted:)
			onKeyStrokeSend: #keystroke:from: to: textModel;
			layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			color: Color white;
			yourself.
	"this is a horrible hack: 
	because we cannot get the update of when the text changes from the morph,
	we get the reference to the mutable text object :) :)"
	textModel text: textMorph textMorph asText. 
	self installActionsOnUI: textModel fromPresentation: aPresentation.
	aPresentation selectedTextBlock: [ textMorph textMorph editor selection ].
	aPresentation textBlock: [ textMorph textMorph editor text ].
	aPresentation when: GLMPresentationUpdated do: [:ann |
		textModel text: aPresentation formatedDisplayValue.
		textModel changed: #text ].
	aPresentation when: GLMContextChanged do: [ :ann | 
		ann property = #selectionInterval
			ifTrue: [ textMorph setSelection: ann value ] ].

	^ textMorph! !

!GLMMorphicWidgetRenderer classSide methodsFor: 'as yet unclassified' stamp: 'tg 8/22/2010 20:20'!
render: aPresentation from: aRenderer
	^ self new 
		renderer: aRenderer;
		render: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 8/22/2010 23:52'!
installActionsOnUI: aMorphicModel fromPresentation: aPresentation	 
	aMorphicModel when: GLMMenuItemSelected do: [ :ann | ann action actOn: aPresentation ].
	aMorphicModel when: GLMKeyStroke do: [ :ann | ann action actOn: aPresentation ].! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 8/22/2010 23:52'!
menuIn: aMenuMorph for: aPresentation
	| subMenus targetMenuMorph subMenu |
	subMenus := Dictionary new.
	(aPresentation allActions select: [:action | action hasTitle ]) do: [ :action |
		targetMenuMorph := action category notNil 
			ifTrue: [ subMenus at: action category ifAbsentPut: [ 
					subMenu :=  MenuMorph new.
					aMenuMorph add: action category subMenu: subMenu.
					subMenu ] ]
			ifFalse: [ aMenuMorph ].
		targetMenuMorph 
			add: action title
			target: action
			selector: #actOn:
			argument: aPresentation ].
	^ aMenuMorph! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 8/22/2010 23:52'!
moreToolbarActions: noIconActions on: aBrowser
	| menuMorph |
	menuMorph := MenuMorph new.
	noIconActions do: [ :each | 
		menuMorph 
				add: each title
				target: each
				selector: #actOn:
				argument: aBrowser ].
	^ menuMorph! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 8/24/2010 22:02'!
morph: aMorph withTitleOf: aPresentation
	| container |
	container := self theme 
		newGroupboxIn: GLMMorphic emptyMorph 
		label: (self titleOrIconOf: aPresentation in: GLMMorphic emptyMorph).
	container addContentMorph: aMorph.
	^ container! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 8/22/2010 23:52'!
morph: aMorph withTitleOrNilOf: aPresentation
	| container empty |
	(aPresentation hasTitle or: [aPresentation hasTitleIcon]) ifFalse: [^ aMorph ].
	empty := GLMMorphic emptyMorph.
	container := self theme 
		newGroupboxIn: empty
		label: (self titleOrIconOrNilOf: aPresentation in: empty).
	container contentMorph cellInset: 2.
	container addContentMorph: aMorph.
	^ container! !

!GLMMorphicWidgetRenderer methodsFor: 'rendering' stamp: 'tg 8/22/2010 20:17'!
render: aPresentation
	^ self subclassResponsibility ! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 8/22/2010 23:46'!
renderObject: anObject
	^ renderer render: anObject ! !

!GLMMorphicWidgetRenderer methodsFor: 'rendering' stamp: 'tg 8/23/2010 00:42'!
renderPaneWithoutTitle: aPane 
	| container |
	container := GLMMorphic emptyMorph.
	aPane when: GLMMatchingPresentationsChanged do: [ :ann | 
		container
			removeAllMorphs;
			addMorph: (self renderObject: aPane presentations)
			fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
			adoptPaneColor: container paneColor.
		renderer window fullBounds.
		renderer window refreshHorizontalScollbars ].
	container
		addMorph: (self renderObject: aPane presentations)
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1));
		adoptPaneColor: container paneColor.
	^ container! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 9/2/2010 17:40'!
renderToolbarForBrowser: aBrowser inWindow: aWin
	| dock tools buttons noIconActions |
	dock := aWin newToolDockingBar.
	buttons := (aBrowser allActions select: [:each | each hasIcon]) collect: [:each |
		(aWin
			newButtonFor: each
			getState: nil
			action: #actOn:
			arguments: {aBrowser}
			getEnabled: nil
			labelForm: each icon
			help: each title)
			valueOfProperty: #noBorder ifAbsentPut: [true];
			valueOfProperty: #noFill ifAbsentPut: [true];
			yourself ].
	noIconActions := aBrowser allActions select: [:each | each hasTitle and: [each hasIcon not]].
	tools := aWin newToolbar: buttons.
	noIconActions isEmpty ifFalse: [ 
		dock 
			add: '...' translated
			font: aWin theme menuBarFont
			icon: nil
			help: 'Browser actions' translated
			subMenu: (self menuIn: MenuMorph new for: aBrowser).
		buttons isEmpty ifFalse: [dock addMorphBack: tools] ]
		ifTrue: [ dock addAllMorphs: buttons ].
	^ dock! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 8/23/2010 00:39'!
renderWithTitle: aPresentation
	| morph |
	morph := self renderObject: aPresentation.
	^ self morph: morph withTitleOf: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 8/23/2010 00:29'!
renderWithTitleOrNil: aPresentation
	| morph |
	morph := self renderObject: aPresentation.
	^ self morph: morph withTitleOrNilOf: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'accessing' stamp: 'tg 8/22/2010 20:20'!
renderer
	^ renderer! !

!GLMMorphicWidgetRenderer methodsFor: 'accessing' stamp: 'tg 8/22/2010 20:20'!
renderer: anObject
	renderer := anObject! !

!GLMMorphicWidgetRenderer methodsFor: 'factory' stamp: 'tg 8/23/2010 00:02'!
theme
	^ UITheme current! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 8/22/2010 23:52'!
titleOrIconOf: aPresentation in: container
	^ aPresentation hasTitleIcon 
		ifTrue: [
			self theme 
					newImageIn: container
					form: aPresentation titleIconValue ]
		ifFalse: [ aPresentation titleValue ifNil: [''] ].! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'tg 8/22/2010 23:52'!
titleOrIconOrNilOf: aPresentation in: container
	^ aPresentation hasTitleIcon 
		ifTrue: [
			self theme 
					newImageIn: container
					form: aPresentation titleIconValue ]
		ifFalse: [ 
			aPresentation hasTitle 
				ifTrue: [ aPresentation titleValue ]
				ifFalse: [ nil ] ]! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicWindowRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic'!

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'tg 8/24/2010 22:06'!
render: aRenderable
	| dock offset bottomOffset statusbarMorph window |
	window := GLMSystemWindow new.
	window model: aRenderable.
	self setLabelOf: window for: aRenderable.
	offset := 0.
	bottomOffset := 0.
	aRenderable allActions notEmpty
		ifTrue: [ 
			dock := self renderToolbarForBrowser: aRenderable inWindow: window.
			offset := dock minExtent y.
			window addMorph: dock fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 0) offsets: (0 @ 0 corner: 0 @ offset)) ].
	aRenderable hasStatusbar
		ifTrue: [ 
			statusbarMorph := self renderPaneWithoutTitle: aRenderable statusbarPane.
			bottomOffset := (0 - (LabelMorph contents: 'XXX') minHeight) * 1.2.
			window
				addMorph: statusbarMorph
				fullFrame: (LayoutFrame fractions: (0 @ 1 corner: 1 @ 1) offsets: (2 @ bottomOffset corner: -2 @ 0)) ].
	window
		addMorph: (self renderObject: aRenderable)
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1) offsets: (0 @ offset corner: 0 @ bottomOffset)).
	(self theme isKindOf: UIThemeWatery)
		ifFalse: [ aRenderable colorValue ifNotNil: [ window paneColor: aRenderable colorValue ] ].
	aRenderable when: GLMPresentationUpdated do: [ :ann |
		self setLabelOf: window for: aRenderable. ].
	^ window! !

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'tg 8/24/2010 22:06'!
setLabelOf: window for: aRenderable
	window	setLabel: (self titleFor: aRenderable).! !

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'tg 8/24/2010 22:04'!
titleFor: aRenderable
	^ aRenderable titleValue ifNil: [ 'Glamorous Browser' ]! !
